/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "graphics_private_clo.h"

static mxArray * Mclo_find_kids(int nargout_, mxArray * obj, mxArray * hsave);
static mxArray * mlfClo_find_kids(mxArray * obj, mxArray * hsave);
static void mlxClo_find_kids(int nlhs,
                             mxArray * plhs[],
                             int nrhs,
                             mxArray * prhs[]);

/*
 * The function "Mgraphics_private_clo" is the implementation version of the
 * "graphics/private/clo" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 1-68). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function ret_obj = clo(obj, in1, in2)
 */
static mxArray * Mgraphics_private_clo(int nargout_,
                                       mxArray * obj,
                                       mxArray * in1,
                                       mxArray * in2) {
    mxArray * ret_obj = mclGetUninitializedArray();
    mxArray * do_reset = mclGetUninitializedArray();
    mxArray * hsave = mclGetUninitializedArray();
    mxArray * kids_to_delete = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mxArray * nargout = mclInitialize(mlfScalar(nargout_));
    mlfAssign(&nargin_, mlfNargin(0, obj, in1, in2, NULL));
    mclValidateInputs("graphics/private/clo", 3, &obj, &in1, &in2);
    /*
     * %CLO Clear object
     * %   CLO(H) deletes all children of the object with visible handles.
     * %
     * %   CLO(..., 'reset') deletes all children (including ones with hidden
     * %   handles) and also resets all object properties to their default
     * %   values.
     * %
     * %   CLO(..., HSAVE) deletes all children except those specified in
     * %   HSAVE.
     * %
     * %   See also CLF, CLA, RESET, HOLD.
     * 
     * %   Copyright (c) 1984-98 by The MathWorks, Inc.
     * %   $Revision: 1.1 $  $Date: 1998/06/29 14:56:08 $
     * 
     * % decode input args:
     * hsave    = [];
     */
    mlfAssign(&hsave, mclCreateEmptyArray());
    /*
     * do_reset = '';
     */
    mlfAssign(&do_reset, mxCreateString(""));
    /*
     * 
     * error(nargchk(1, 3, nargin));
     */
    mlfError(mlfNargchk(mlfScalar(1.0), mlfScalar(3.0), nargin_));
    /*
     * 
     * if nargin > 1
     */
    if (mlfTobool(mlfGt(nargin_, mlfScalar(1.0)))) {
        /*
         * if   isstr(in1), do_reset = in1; else, hsave = in1; end
         */
        if (mlfTobool(mlfIsstr(in1))) {
            mlfAssign(&do_reset, in1);
        } else {
            mlfAssign(&hsave, in1);
        }
        /*
         * if nargin > 2
         */
        if (mlfTobool(mlfGt(nargin_, mlfScalar(2.0)))) {
            /*
             * if isstr(in2), do_reset = in2; else, hsave = in2; end
             */
            if (mlfTobool(mlfIsstr(in2))) {
                mlfAssign(&do_reset, in2);
            } else {
                mlfAssign(&hsave, in2);
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * % error-check input args
     * if ~isempty(do_reset)
     */
    if (mlfTobool(mlfNot(mlfIsempty(do_reset)))) {
        /*
         * if ~strcmp(do_reset, 'reset')
         */
        if (mlfTobool(mlfNot(mlfStrcmp(do_reset, mxCreateString("reset"))))) {
            /*
             * error('Unknown command option.')
             */
            mlfError(mxCreateString("Unknown command option."));
        /*
         * else
         */
        } else {
            /*
             * do_reset = 1;
             */
            mlfAssign(&do_reset, mlfScalar(1.0));
        /*
         * end
         */
        }
    /*
     * else
     */
    } else {
        /*
         * do_reset = 0;
         */
        mlfAssign(&do_reset, mlfScalar(0.0));
    /*
     * end
     */
    }
    /*
     * 
     * if any(~ishandle(hsave))
     */
    if (mlfTobool(mlfAny(mlfNot(mlfIshandle(hsave)), NULL))) {
        /*
         * error('Bad handle')
         */
        mlfError(mxCreateString("Bad handle"));
    /*
     * end
     */
    }
    /*
     * 
     * hsave = find_kids(obj, hsave);
     */
    mlfAssign(&hsave, mlfClo_find_kids(obj, hsave));
    /*
     * 
     * kids_to_delete = [];
     */
    mlfAssign(&kids_to_delete, mclCreateEmptyArray());
    /*
     * if do_reset
     */
    if (mlfTobool(do_reset)) {
        /*
         * kids_to_delete = findobj(allchild(obj),'flat','serializable','on');
         */
        mlfAssign(
          &kids_to_delete,
          mlfFindobj(
            mlfAllchild(obj),
            mxCreateString("flat"),
            mxCreateString("serializable"),
            mxCreateString("on"),
            NULL));
    /*
     * else
     */
    } else {
        /*
         * kids_to_delete =  findobj(get(obj,'Children'),'flat',...
         */
        mlfAssign(
          &kids_to_delete,
          mlfFindobj(
            mlfGet(obj, mxCreateString("Children"), NULL),
            mxCreateString("flat"),
            mxCreateString("HandleVisibility"),
            mxCreateString("on"),
            mxCreateString("serializable"),
            mxCreateString("on"),
            NULL));
    /*
     * 'HandleVisibility','on', 'serializable','on');
     * end
     */
    }
    /*
     * 
     * kids_to_delete = setdiff(kids_to_delete, hsave);
     */
    mlfAssign(&kids_to_delete, mlfSetdiff(NULL, kids_to_delete, hsave, NULL));
    /*
     * 
     * delete(kids_to_delete);
     */
    mlfDelete(kids_to_delete, NULL);
    /*
     * 
     * if do_reset, reset(obj(ishandle(obj))), end
     */
    if (mlfTobool(do_reset)) {
        mlfReset(mlfIndexRef(obj, "(?)", mlfIshandle(obj)));
    }
    /*
     * 
     * % now that IntegerHandle can be changed by reset, make sure
     * % we're returning the new handle:
     * if (nargout ~= 0)
     */
    if (mlfTobool(mlfNe(nargout, mlfScalar(0.0)))) {
        /*
         * ret_obj = obj(ishandle(obj));
         */
        mlfAssign(&ret_obj, mlfIndexRef(obj, "(?)", mlfIshandle(obj)));
    /*
     * end
     */
    }
    mclValidateOutputs("graphics/private/clo", 1, nargout_, &ret_obj);
    mxDestroyArray(do_reset);
    mxDestroyArray(hsave);
    mxDestroyArray(kids_to_delete);
    mxDestroyArray(nargin_);
    mxDestroyArray(nargout);
    /*
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * function hsave_out = find_kids(obj, hsave)
     * %
     * %
     * %
     * hsave_out = [];
     * for kid=hsave(:)'
     * while ~isempty(kid)
     * parent = get(kid,'parent');
     * if ~isempty(parent) & parent == obj
     * hsave_out(end + 1) = kid;
     * break;
     * else
     * kid = parent;
     * end
     * end
     * end
     * 
     */
    return ret_obj;
}

/*
 * The function "mlfNGraphics_private_clo" contains the nargout interface for
 * the "graphics/private/clo" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 1-68). This
 * interface is only produced if the M-function uses the special variable
 * "nargout". The nargout interface allows the number of requested outputs to
 * be specified via the nargout argument, as opposed to the normal interface
 * which dynamically calculates the number of outputs based on the number of
 * non-NULL inputs it receives. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
mxArray * mlfNGraphics_private_clo(int nargout,
                                   mxArray * obj,
                                   mxArray * in1,
                                   mxArray * in2) {
    mxArray * ret_obj = mclGetUninitializedArray();
    mlfEnterNewContext(0, 3, obj, in1, in2);
    ret_obj = Mgraphics_private_clo(nargout, obj, in1, in2);
    mlfRestorePreviousContext(0, 3, obj, in1, in2);
    return mlfReturnValue(ret_obj);
}

/*
 * The function "mlfGraphics_private_clo" contains the normal interface for the
 * "graphics/private/clo" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 1-68). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
mxArray * mlfGraphics_private_clo(mxArray * obj, mxArray * in1, mxArray * in2) {
    int nargout = 1;
    mxArray * ret_obj = mclGetUninitializedArray();
    mlfEnterNewContext(0, 3, obj, in1, in2);
    ret_obj = Mgraphics_private_clo(nargout, obj, in1, in2);
    mlfRestorePreviousContext(0, 3, obj, in1, in2);
    return mlfReturnValue(ret_obj);
}

/*
 * The function "mlfVGraphics_private_clo" contains the void interface for the
 * "graphics/private/clo" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 1-68). The void
 * interface is only produced if the M-function uses the special variable
 * "nargout", and has at least one output. The void interface function
 * specifies zero output arguments to the implementation version of the
 * function, and in the event that the implementation version still returns an
 * output (which, in MATLAB, would be assigned to the "ans" variable), it
 * deallocates the output. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlfVGraphics_private_clo(mxArray * obj, mxArray * in1, mxArray * in2) {
    mxArray * ret_obj = mclUnassigned();
    mlfEnterNewContext(0, 3, obj, in1, in2);
    ret_obj = Mgraphics_private_clo(0, obj, in1, in2);
    mlfRestorePreviousContext(0, 3, obj, in1, in2);
    mxDestroyArray(ret_obj);
}

/*
 * The function "mlxGraphics_private_clo" contains the feval interface for the
 * "graphics/private/clo" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 1-68). The feval
 * function calls the implementation version of graphics/private/clo through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxGraphics_private_clo(int nlhs,
                             mxArray * plhs[],
                             int nrhs,
                             mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: graphics/private/clo Line: 1 Col"
            "umn: 0 The function \"graphics/private/clo\" was calle"
            "d with more than the declared number of outputs (1)"));
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: graphics/private/clo Line: 1 Col"
            "umn: 0 The function \"graphics/private/clo\" was calle"
            "d with more than the declared number of inputs (3)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mgraphics_private_clo(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mclo_find_kids" is the implementation version of the
 * "clo/find_kids" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 68-85). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function hsave_out = find_kids(obj, hsave)
 */
static mxArray * Mclo_find_kids(int nargout_, mxArray * obj, mxArray * hsave) {
    mxArray * hsave_out = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * kid = mclGetUninitializedArray();
    mxArray * parent = mclGetUninitializedArray();
    mclValidateInputs("clo/find_kids", 2, &obj, &hsave);
    /*
     * %
     * %
     * %
     * hsave_out = [];
     */
    mlfAssign(&hsave_out, mclCreateEmptyArray());
    /*
     * for kid=hsave(:)'
     */
    for (mclForStart(
           &iterator_0,
           mlfCtranspose(mlfIndexRef(hsave, "(?)", mlfCreateColonIndex())),
           NULL,
           NULL);
         mclForNext(&iterator_0, &kid);
         ) {
        /*
         * while ~isempty(kid)
         */
        while (mlfTobool(mlfNot(mlfIsempty(kid)))) {
            /*
             * parent = get(kid,'parent');
             */
            mlfAssign(&parent, mlfGet(kid, mxCreateString("parent"), NULL));
            /*
             * if ~isempty(parent) & parent == obj
             */
            {
                mxArray * a_ = mclInitialize(mlfNot(mlfIsempty(parent)));
                if (mlfTobool(a_)
                    && mlfTobool(mlfAnd(a_, mlfEq(parent, obj)))) {
                    mxDestroyArray(a_);
                    /*
                     * hsave_out(end + 1) = kid;
                     */
                    mlfIndexAssign(
                      &hsave_out,
                      "(?)",
                      mlfPlus(
                        mlfEnd(hsave_out, mlfScalar(1), mlfScalar(1)),
                        mlfScalar(1.0)),
                      kid);
                    /*
                     * break;
                     */
                    mclDestroyForLoopIterator(&iterator_0);
                    break;
                /*
                 * else
                 */
                } else {
                    mxDestroyArray(a_);
                    /*
                     * kid = parent;
                     */
                    mlfAssign(&kid, parent);
                }
            /*
             * end
             */
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    mclValidateOutputs("clo/find_kids", 1, nargout_, &hsave_out);
    mxDestroyArray(kid);
    mxDestroyArray(parent);
    /*
     * 
     */
    return hsave_out;
}

/*
 * The function "mlfClo_find_kids" contains the normal interface for the
 * "clo/find_kids" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 68-85). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
static mxArray * mlfClo_find_kids(mxArray * obj, mxArray * hsave) {
    int nargout = 1;
    mxArray * hsave_out = mclGetUninitializedArray();
    mlfEnterNewContext(0, 2, obj, hsave);
    hsave_out = Mclo_find_kids(nargout, obj, hsave);
    mlfRestorePreviousContext(0, 2, obj, hsave);
    return mlfReturnValue(hsave_out);
}

/*
 * The function "mlxClo_find_kids" contains the feval interface for the
 * "clo/find_kids" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graphics\private\clo.m" (lines 68-85). The
 * feval function calls the implementation version of clo/find_kids through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
static void mlxClo_find_kids(int nlhs,
                             mxArray * plhs[],
                             int nrhs,
                             mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: clo/find_kids Line: 68 Colum"
            "n: 0 The function \"clo/find_kids\" was called wit"
            "h more than the declared number of outputs (1)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: clo/find_kids Line: 68 Colum"
            "n: 0 The function \"clo/find_kids\" was called wit"
            "h more than the declared number of inputs (2)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    mplhs[0] = Mclo_find_kids(nlhs, mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
    plhs[0] = mplhs[0];
}
