/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:21 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "lsqnonlin.h"
#include "optim_private_checkbounds.h"
#include "optim_private_diagnose.h"
#include "optim_private_nlsq.h"
#include "optim_private_snls.h"
#include "optim_private_startx.h"

static mxArray * Mlsqnonlin(mxArray * * Resnorm,
                            mxArray * * FVAL,
                            mxArray * * EXITFLAG,
                            mxArray * * OUTPUT,
                            mxArray * * LAMBDA,
                            mxArray * * JACOB,
                            int nargout_,
                            mxArray * FUN,
                            mxArray * x_,
                            mxArray * LB,
                            mxArray * UB,
                            mxArray * options,
                            mxArray * varargin);
static mxArray * Mlsqnonlin_fprefcnchk(mxArray * * msg,
                                       int nargout_,
                                       mxArray * funstr,
                                       mxArray * caller,
                                       mxArray * lenVarIn,
                                       mxArray * gradflag);
static mxArray * mlfLsqnonlin_fprefcnchk(mxArray * * msg,
                                         mxArray * funstr,
                                         mxArray * caller,
                                         mxArray * lenVarIn,
                                         mxArray * gradflag);
static void mlxLsqnonlin_fprefcnchk(int nlhs,
                                    mxArray * plhs[],
                                    int nrhs,
                                    mxArray * prhs[]);

static mlfFunctionTableEntry local_function_table_[1]
  = { { "fprefcnchk", mlxLsqnonlin_fprefcnchk, 4, 2 } };

/*
 * The function "Mlsqnonlin" is the implementation version of the "lsqnonlin"
 * M-function from file "C:\MATLABR11\toolbox\optim\lsqnonlin.m" (lines 1-254).
 * It contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [x,Resnorm,FVAL,EXITFLAG,OUTPUT,LAMBDA,JACOB] = lsqnonlin(FUN,x,LB,UB,options,varargin)
 */
static mxArray * Mlsqnonlin(mxArray * * Resnorm,
                            mxArray * * FVAL,
                            mxArray * * EXITFLAG,
                            mxArray * * OUTPUT,
                            mxArray * * LAMBDA,
                            mxArray * * JACOB,
                            int nargout_,
                            mxArray * FUN,
                            mxArray * x_,
                            mxArray * LB,
                            mxArray * UB,
                            mxArray * options,
                            mxArray * varargin) {
    mxArray * x = mclGetUninitializedArray();
    mxArray * HESS = mclGetUninitializedArray();
    mxArray * JAC = mclGetUninitializedArray();
    mxArray * Jcols = mclGetUninitializedArray();
    mxArray * Jrows = mclGetUninitializedArray();
    mxArray * Jstr = mclGetUninitializedArray();
    mxArray * YDATA = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * c = mclGetUninitializedArray();
    mxArray * cGRAD = mclGetUninitializedArray();
    mxArray * caller = mclGetUninitializedArray();
    mxArray * ceq = mclGetUninitializedArray();
    mxArray * ceqGRAD = mclGetUninitializedArray();
    mxArray * computeLambda = mclGetUninitializedArray();
    mxArray * confcn = mclGetUninitializedArray();
    mxArray * constflag = mclGetUninitializedArray();
    mxArray * defaultopt = mclGetUninitializedArray();
    mxArray * diagnostics = mclGetUninitializedArray();
    mxArray * errmsg = mclGetUninitializedArray();
    mxArray * errstr = mclGetUninitializedArray();
    mxArray * f = mclGetUninitializedArray();
    mxArray * funfcn = mclGetUninitializedArray();
    mxArray * fuser = mclGetUninitializedArray();
    mxArray * gradconstflag = mclGetUninitializedArray();
    mxArray * gradflag = mclGetUninitializedArray();
    mxArray * hessflag = mclGetUninitializedArray();
    mxArray * l = mclGetUninitializedArray();
    mxArray * lFinite = mclGetUninitializedArray();
    mxArray * large = mclGetUninitializedArray();
    mxArray * lin_eq = mclGetUninitializedArray();
    mxArray * lin_ineq = mclGetUninitializedArray();
    mxArray * line_search = mclGetUninitializedArray();
    mxArray * medium = mclGetUninitializedArray();
    mxArray * msg = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mxArray * nargout = mclInitialize(mlfScalar(nargout_));
    mxArray * nfun = mclGetUninitializedArray();
    mxArray * non_eq = mclGetUninitializedArray();
    mxArray * non_ineq = mclGetUninitializedArray();
    mxArray * numberOfVariables = mclGetUninitializedArray();
    mxArray * u = mclGetUninitializedArray();
    mxArray * uFinite = mclGetUninitializedArray();
    mxArray * verbosity = mclGetUninitializedArray();
    mxArray * warnstr = mclGetUninitializedArray();
    mxArray * xstart = mclGetUninitializedArray();
    mlfAssign(&nargin_, mlfNargin(1, FUN, x_, LB, UB, options, varargin, NULL));
    mclValidateInputs("lsqnonlin", 5, &FUN, &x_, &LB, &UB, &options);
    mclCopyArray(&LB);
    mclCopyArray(&UB);
    mclCopyArray(&options);
    mclCopyInputArg(&x, x_);
    /*
     * %LSQNONLIN Solves non-linear least squares problems.
     * %   LSQNONLIN solves problems of the form:
     * %   min  sum {FUN(X).^2}    where X and the values returned by FUN can be   
     * %             x             vectors or matrices.
     * %
     * %   X=LSQNONLIN(FUN,X0) starts at the matrix X0 and finds a minimum to the
     * %   sum of squares of the functions described in FUN. FUN is usually
     * %   an M-file which returns a vector of objective functions: F=FUN(X).
     * %   NOTE: FUN should return FUN(X) and not the sum-of-squares 
     * %   sum(FUN(X).^2)). (FUN(X) is summed and squared implicitly in
     * %   the algorithm.) See below for more options for FUN.
     * %
     * %   X=LSQNONLIN(FUN,X0,LB,UB) defines a set of lower and upper
     * %   bounds on the design variables, X, so that the solution is in
     * %   the range LB <= X <= UB.  Use empty matrices for LB and UB
     * %   if no bounds exist. Set LB(i) = -inf if X(i) is unbounded below; 
     * %   set UB(i) = inf if X(i) is unbounded above.
     * %
     * %   X=LSQNONLIN(FUN,X0,LB,UB,OPTIONS) minimizes with the default optimization
     * %   parameters replaced by values in the structure OPTIONS, an argument
     * %   created with the OPTIMSET function.  See OPTIMSET for details.  Used
     * %   options are Display, TolX, TolFun, DerivativeCheck, Diagnostics, Jacobian,
     * %   JacobPattern, LineSearchType, LevenbergMarquardt, MaxFunEvals, MaxIter, 
     * %   DiffMinChange and DiffMaxChange, LargeScale, MaxPCGIter, PrecondBandWidth,
     * %   TolPCG, TypicalX. Use the Jacobian option to specify that FUN may be 
     * %   called with two output arguments where the second, J, is the Jacobian 
     * %   matrix: [F,J] = feval(FUN,X). If FUN returns a vector (matrix) of m 
     * %   components when X has length n, then J is an m-by-n matrix where J(i,j) 
     * %   is the partial derivative of F(i) with respect to x(j). (Note that the 
     * %   Jacobian J is the transpose of the gradient of F.)
     * %
     * %   X=LSQNONLIN(FUN,X0,LB,UB,OPTIONS,P1,P2,..) passes the 
     * %   problem-dependent parameters P1,P2,... directly to the functions FUN: 
     * %   FUN(X,P1,P2,...).  Pass an empty matrix for OPTIONS to use the default 
     * %   values.
     * %
     * %   [X,RESNORM]=LSQNONLIN(FUN,X0,...) returns 
     * %   the value of the squared 2-norm of the residual at X: sum(FUN(X).^2). 
     * %
     * %   [X,RESNORM,RESIDUAL]=LSQNONLIN(FUN,X0,...) returns the value of the 
     * %   residual at the solution X: RESIDUAL = FUN(X).
     * %
     * %   [X,RESNORM,RESIDUAL,EXITFLAG]=LSQNONLIN(FUN,X0,...) returns a string   
     * %   EXITFLAG that describes the exit condition of LSQNONLIN.  
     * %   If EXITFLAG is:
     * %      > 0 then LSQNONLIN converged to a solution X.
     * %      0   then the maximum number of function evaluations was reached.
     * %      < 0 then LSQNONLIN did not converge to a solution.
     * %
     * %   [X,RESNORM,RESIDUAL,EXITFLAG,OUTPUT]=LSQNONLIN(FUN,X0,...) returns a 
     * %   structure OUTPUT with the number of iterations taken in OUTPUT.iterations, 
     * %   the number of function evaluations in OUTPUT.funcCount, the algorithm used 
     * %   in OUTPUT.algorithm, the number of CG iterations (if used) in OUTPUT.cgiterations,  
     * %   and the first-order optimality (if used) in OUTPUT.firstorderopt.
     * %
     * %   [X,RESNORM,RESIDUAL,EXITFLAG,OUTPUT,LAMBDA]=LSQNONLIN(FUN,X0,...) returns 
     * %   the set of Lagrangian multipliers, LAMBDA, at the solution: LAMBDA.lower 
     * %   for LB and LAMBDA.upper for UB.
     * %
     * %   [X,RESNORM,RESIDUAL,EXITFLAG,OUTPUT,LAMBDA,JACOBIAN]=LSQNONLIN(FUN,X0,...) 
     * %   returns the Jacobian of FUN at X.   
     * %
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.24 $  $Date: 1998/10/22 20:11:13 $
     * %   Andy Grace 7-9-90.
     * %   revised by Wes Wang 6-29-93.
     * 
     * %   The default algorithm is the Levenberg-Marquardt method with a 
     * %   mixed quadratic and cubic line search procedure.  A Gauss-Newton
     * %   method is selected by setting  OPTIONS(5)=1. 
     * %
     * 
     * % ------------Initialization----------------
     * 
     * 
     * defaultopt = optimset('display','final','LargeScale','on', ...
     */
    mlfAssign(
      &defaultopt,
      mlfNOptimset(
        1,
        mxCreateString("display"),
        mxCreateString("final"),
        mxCreateString("LargeScale"),
        mxCreateString("on"),
        mxCreateString("TolX"),
        mlfScalar(1e-6),
        mxCreateString("TolFun"),
        mlfScalar(1e-6),
        mxCreateString("DerivativeCheck"),
        mxCreateString("off"),
        mxCreateString("Diagnostics"),
        mxCreateString("off"),
        mxCreateString("Jacobian"),
        mxCreateString("off"),
        mxCreateString("MaxFunEvals"),
        mxCreateString("100*numberOfVariables"),
        mxCreateString("DiffMaxChange"),
        mlfScalar(1e-1),
        mxCreateString("DiffMinChange"),
        mlfScalar(1e-8),
        mxCreateString("PrecondBandWidth"),
        mlfScalar(0.0),
        mxCreateString("TypicalX"),
        mxCreateString("ones(numberOfVariables,1)"),
        mxCreateString("MaxPCGIter"),
        mxCreateString("max(1,floor(numberOfVariables/2))"),
        mxCreateString("TolPCG"),
        mlfScalar(0.1),
        mxCreateString("MaxIter"),
        mlfScalar(400.0),
        mxCreateString("JacobPattern"),
        mclCreateEmptyArray(),
        mxCreateString("LineSearchType"),
        mxCreateString("quadcubic"),
        mxCreateString("LevenbergMarq"),
        mxCreateString("on"),
        NULL));
    /*
     * 'TolX',1e-6,'TolFun',1e-6,'DerivativeCheck','off',...
     * 'Diagnostics','off',...
     * 'Jacobian','off','MaxFunEvals','100*numberOfVariables',...
     * 'DiffMaxChange',1e-1,'DiffMinChange',1e-8,...
     * 'PrecondBandWidth',0,'TypicalX','ones(numberOfVariables,1)','MaxPCGIter','max(1,floor(numberOfVariables/2))', ...
     * 'TolPCG',0.1,'MaxIter',400,'JacobPattern',[], ...
     * 'LineSearchType','quadcubic','LevenbergMarq','on'); 
     * 
     * % If just 'defaults' passed in, return the default options in X
     * if nargin==1 & nargout <= 1 & isequal(FUN,'defaults')
     */
    {
        mxArray * a_ = mclInitialize(mlfEq(nargin_, mlfScalar(1.0)));
        if (mlfTobool(a_)) {
            mlfAssign(&a_, mlfAnd(a_, mlfLe(nargout, mlfScalar(1.0))));
        } else {
            mlfAssign(&a_, mlfScalar(0));
        }
        if (mlfTobool(a_)
            && mlfTobool(
                 mlfAnd(
                   a_, mlfIsequal(FUN, mxCreateString("defaults"), NULL)))) {
            mxDestroyArray(a_);
            /*
             * x = defaultopt;
             */
            mlfAssign(&x, defaultopt);
            /*
             * return
             */
            goto return_;
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * xstart=x(:);
     */
    mlfAssign(&xstart, mlfIndexRef(x, "(?)", mlfCreateColonIndex()));
    /*
     * numberOfVariables=length(xstart);
     */
    mlfAssign(&numberOfVariables, mlfLength(xstart));
    /*
     * 
     * large = 'large-scale';
     */
    mlfAssign(&large, mxCreateString("large-scale"));
    /*
     * medium = 'medium-scale';
     */
    mlfAssign(&medium, mxCreateString("medium-scale"));
    /*
     * 
     * if nargin < 2, error('LSQNONLIN requires two input arguments');end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(2.0)))) {
        mlfError(mxCreateString("LSQNONLIN requires two input arguments"));
    }
    /*
     * if nargin < 3, LB=[]; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(3.0)))) {
        mlfAssign(&LB, mclCreateEmptyArray());
    }
    /*
     * if nargin < 4, UB=[]; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(4.0)))) {
        mlfAssign(&UB, mclCreateEmptyArray());
    }
    /*
     * if nargin < 5, options=[]; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(5.0)))) {
        mlfAssign(&options, mclCreateEmptyArray());
    }
    /*
     * if nargout > 5
     */
    if (mlfTobool(mlfGt(nargout, mlfScalar(5.0)))) {
        /*
         * computeLambda = 1;
         */
        mlfAssign(&computeLambda, mlfScalar(1.0));
    /*
     * else 
     */
    } else {
        /*
         * computeLambda = 0;
         */
        mlfAssign(&computeLambda, mlfScalar(0.0));
    /*
     * end
     */
    }
    /*
     * 
     * options = optimset(defaultopt,options);
     */
    mlfAssign(&options, mlfNOptimset(1, defaultopt, options, NULL));
    /*
     * switch optimget(options,'display')
     */
    {
        mxArray * t_ = mclUnassigned();
        mlfAssign(&t_, mlfOptimget(options, mxCreateString("display"), NULL));
        /*
         * case {'off','none'}
         */
        if (mclSwitchCompare(
              t_,
              mlfCellhcat(
                mxCreateString("off"), mxCreateString("none"), NULL))) {
            /*
             * verbosity = 0;
             */
            mlfAssign(&verbosity, mlfScalar(0.0));
        /*
         * case 'iter'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("iter"))) {
            /*
             * verbosity = 2;
             */
            mlfAssign(&verbosity, mlfScalar(2.0));
        /*
         * case 'final'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("final"))) {
            /*
             * verbosity = 1;
             */
            mlfAssign(&verbosity, mlfScalar(1.0));
        /*
         * case 'testing'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("testing"))) {
            /*
             * verbosity = Inf;
             */
            mlfAssign(&verbosity, mlfInf());
        /*
         * otherwise
         */
        } else {
            /*
             * verbosity = 1;
             */
            mlfAssign(&verbosity, mlfScalar(1.0));
        /*
         * end
         */
        }
        mxDestroyArray(t_);
    }
    /*
     * 
     * [xstart,l,u,msg] = checkbounds(xstart,LB,UB,numberOfVariables);
     */
    mlfAssign(
      &xstart,
      mlfOptim_private_checkbounds(
        &l, &u, &msg, xstart, LB, UB, numberOfVariables));
    /*
     * if ~isempty(msg)
     */
    if (mlfTobool(mlfNot(mlfIsempty(msg)))) {
        /*
         * EXITFLAG = -1;
         */
        mlfAssign(EXITFLAG, mlfScalar(-1.0));
        /*
         * [Resnorm,FVAL,OUTPUT,LAMBDA,JACOB] = deal([]);
         */
        mlfNDeal(
          0,
          mlfVarargout(Resnorm, FVAL, OUTPUT, LAMBDA, JACOB, NULL),
          mclCreateEmptyArray(),
          NULL);
        /*
         * x(:)=xstart;
         */
        mlfIndexAssign(&x, "(?)", mlfCreateColonIndex(), xstart);
        /*
         * if verbosity > 0
         */
        if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
            /*
             * disp(msg)
             */
            mlfDisp(msg);
        /*
         * end
         */
        }
        /*
         * return
         */
        goto return_;
    /*
     * end
     */
    }
    /*
     * lFinite = ~isinf(l);
     */
    mlfAssign(&lFinite, mlfNot(mlfIsinf(l)));
    /*
     * uFinite = ~isinf(u);
     */
    mlfAssign(&uFinite, mlfNot(mlfIsinf(u)));
    /*
     * 
     * if min(min(u-xstart),min(xstart-l)) < 0
     */
    if (mlfTobool(
          mlfLt(
            mlfMin(
              NULL,
              mlfMin(NULL, mlfMinus(u, xstart), NULL, NULL),
              mlfMin(NULL, mlfMinus(xstart, l), NULL, NULL),
              NULL),
            mlfScalar(0.0)))) {
        /*
         * xstart = startx(u,l); 
         */
        mlfAssign(&xstart, mlfOptim_private_startx(u, l));
    /*
     * end
     */
    }
    /*
     * 
     * diagnostics = isequal(optimget(options,'diagnostics','off'),'on');
     */
    mlfAssign(
      &diagnostics,
      mlfIsequal(
        mlfOptimget(
          options, mxCreateString("diagnostics"), mxCreateString("off")),
        mxCreateString("on"), NULL));
    /*
     * gradflag =  strcmp(optimget(options,'Jacobian'),'on');
     */
    mlfAssign(
      &gradflag,
      mlfStrcmp(
        mlfOptimget(options, mxCreateString("Jacobian"), NULL),
        mxCreateString("on")));
    /*
     * line_search = strcmp(optimget(options,'largescale','off'),'off'); % 0 means large-scale, 1 means line-search
     */
    mlfAssign(
      &line_search,
      mlfStrcmp(
        mlfOptimget(
          options, mxCreateString("largescale"), mxCreateString("off")),
        mxCreateString("off")));
    /*
     * 
     * % Convert to inline function as needed
     * if ~isempty(FUN)  % will detect empty string, empty matrix, empty cell array
     */
    if (mlfTobool(mlfNot(mlfIsempty(FUN)))) {
        /*
         * [funfcn, msg] = fprefcnchk(FUN,'lsqnonlin',length(varargin),gradflag);
         */
        mlfAssign(
          &funfcn,
          mlfLsqnonlin_fprefcnchk(
            &msg,
            FUN,
            mxCreateString("lsqnonlin"),
            mlfLength(varargin),
            gradflag));
    /*
     * else
     */
    } else {
        /*
         * errmsg = sprintf('%s\n%s', ...
         */
        mlfAssign(
          &errmsg,
          mlfSprintf(
            NULL,
            mxCreateString("%s\\n%s"),
            mxCreateString(
              "FUN must be a function name, valid st"
              "ring expression, or inline object;"),
            mxCreateString(
              " or, FUN may be a cell array that "
              "contains these type of objects."),
            NULL));
        /*
         * 'FUN must be a function name, valid string expression, or inline object;', ...
         * ' or, FUN may be a cell array that contains these type of objects.');
         * error(errmsg)
         */
        mlfError(errmsg);
    /*
     * end
     */
    }
    /*
     * 
     * x(:) = xstart;
     */
    mlfIndexAssign(&x, "(?)", mlfCreateColonIndex(), xstart);
    /*
     * switch funfcn{1}
     */
    {
        mxArray * t_ = mclUnassigned();
        mlfAssign(&t_, mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)));
        /*
         * case 'fun'
         */
        if (mclSwitchCompare(t_, mxCreateString("fun"))) {
            /*
             * fuser = feval(funfcn{3},x,varargin{:});
             */
            mlfAssign(
              &fuser,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(
                  mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                  1,
                  local_function_table_),
                x,
                mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                NULL));
            /*
             * f = fuser(:);
             */
            mlfAssign(&f, mlfIndexRef(fuser, "(?)", mlfCreateColonIndex()));
            /*
             * nfun=length(f);
             */
            mlfAssign(&nfun, mlfLength(f));
            /*
             * JAC = zeros(nfun,numberOfVariables);
             */
            mlfAssign(&JAC, mlfZeros(nfun, numberOfVariables, NULL));
        /*
         * case 'fungrad'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("fungrad"))) {
            /*
             * [fuser,JAC] = feval(funfcn{3},x,varargin{:});
             */
            mlfFeval(
              mlfVarargout(&fuser, &JAC, NULL),
              mclFevalLookup(
                mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                1,
                local_function_table_),
              x,
              mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
              NULL);
            /*
             * f = fuser(:);
             */
            mlfAssign(&f, mlfIndexRef(fuser, "(?)", mlfCreateColonIndex()));
            /*
             * nfun=length(f);
             */
            mlfAssign(&nfun, mlfLength(f));
        /*
         * case 'fun_then_grad'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("fun_then_grad"))) {
            /*
             * fuser = feval(funfcn{3},x,varargin{:}); 
             */
            mlfAssign(
              &fuser,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(
                  mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                  1,
                  local_function_table_),
                x,
                mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                NULL));
            /*
             * f = fuser(:);
             */
            mlfAssign(&f, mlfIndexRef(fuser, "(?)", mlfCreateColonIndex()));
            /*
             * JAC = feval(funfcn{4},x,varargin{:});
             */
            mlfAssign(
              &JAC,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(
                  mlfIndexRef(funfcn, "{?}", mlfScalar(4.0)),
                  1,
                  local_function_table_),
                x,
                mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                NULL));
            /*
             * nfun=length(f);
             */
            mlfAssign(&nfun, mlfLength(f));
        /*
         * otherwise
         */
        } else {
            /*
             * error('Undefined calltype in LSQNONLIN');
             */
            mlfError(mxCreateString("Undefined calltype in LSQNONLIN"));
        /*
         * end
         */
        }
        mxDestroyArray(t_);
    }
    /*
     * 
     * % check size of JAC
     * [Jrows, Jcols]=size(JAC);
     */
    mlfSize(mlfVarargout(&Jrows, &Jcols, NULL), JAC, NULL);
    /*
     * if Jrows~=nfun | Jcols ~=numberOfVariables
     */
    {
        mxArray * a_ = mclInitialize(mlfNe(Jrows, nfun));
        if (mlfTobool(a_)
            || mlfTobool(mlfOr(a_, mlfNe(Jcols, numberOfVariables)))) {
            mxDestroyArray(a_);
            /*
             * errstr = sprintf('%s\n%s%d%s%d\n',...
             */
            mlfAssign(
              &errstr,
              mlfSprintf(
                NULL,
                mxCreateString("%s\\n%s%d%s%d\\n"),
                mxCreateString(
                  "User-defined Jacobian is not the correct size:"),
                mxCreateString("    the Jacobian matrix should be "),
                nfun,
                mxCreateString("-by-"),
                numberOfVariables,
                NULL));
            /*
             * 'User-defined Jacobian is not the correct size:',...
             * '    the Jacobian matrix should be ',nfun,'-by-',numberOfVariables);
             * error(errstr);
             */
            mlfError(errstr);
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * YDATA = []; caller = 'lsqnonlin';
     */
    mlfAssign(&YDATA, mclCreateEmptyArray());
    mlfAssign(&caller, mxCreateString("lsqnonlin"));
    /*
     * 
     * % trustregion and enough equations (as many as variables) 
     * if ~line_search & nfun >= numberOfVariables 
     */
    {
        mxArray * a_ = mclInitialize(mlfNot(line_search));
        if (mlfTobool(a_)
            && mlfTobool(mlfAnd(a_, mlfGe(nfun, numberOfVariables)))) {
            mxDestroyArray(a_);
            /*
             * OUTPUT.algorithm = large;
             */
            mlfIndexAssign(OUTPUT, ".algorithm", large);
        /*
         * 
         * % trust region and not enough equations -- switch to line_search
         * elseif ~line_search & nfun < numberOfVariables 
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_ = mclInitialize(mlfNot(line_search));
                if (mlfTobool(a_)
                    && mlfTobool(mlfAnd(a_, mlfLt(nfun, numberOfVariables)))) {
                    mxDestroyArray(a_);
                    /*
                     * warnstr = sprintf('%s\n%s\n', ...
                     */
                    mlfAssign(
                      &warnstr,
                      mlfSprintf(
                        NULL,
                        mxCreateString("%s\\n%s\\n"),
                        mxCreateString(
                          "Large-scale method requires at least"
                          " as many equations as variables; "),
                        mxCreateString(
                          "   switching to line-search method instead."
                          "  Upper and lower bounds will be ignored."),
                        NULL));
                    /*
                     * 'Large-scale method requires at least as many equations as variables; ',...
                     * '   switching to line-search method instead.  Upper and lower bounds will be ignored.');
                     * warning(warnstr);
                     */
                    mclAssignAns(&ans, mlfWarning(NULL, warnstr));
                    /*
                     * OUTPUT.algorithm = medium; 
                     */
                    mlfIndexAssign(OUTPUT, ".algorithm", medium);
                /*
                 * 
                 * % line search and no bounds  
                 * elseif line_search & isempty(l(lFinite)) & isempty(u(uFinite))
                 */
                } else {
                    mxDestroyArray(a_);
                    {
                        mxArray * a_ = mclInitialize(line_search);
                        if (mlfTobool(a_)) {
                            mlfAssign(
                              &a_,
                              mlfAnd(
                                a_,
                                mlfIsempty(mlfIndexRef(l, "(?)", lFinite))));
                        } else {
                            mlfAssign(&a_, mlfScalar(0));
                        }
                        if (mlfTobool(a_)
                            && mlfTobool(
                                 mlfAnd(
                                   a_,
                                   mlfIsempty(
                                     mlfIndexRef(u, "(?)", uFinite))))) {
                            mxDestroyArray(a_);
                            /*
                             * OUTPUT.algorithm = medium; 
                             */
                            mlfIndexAssign(OUTPUT, ".algorithm", medium);
                        /*
                         * 
                         * % line search and  bounds  and enough equations, switch to trust region 
                         * elseif line_search & (~isempty(l(lFinite)) | ~isempty(u(uFinite)))  & nfun >= numberOfVariables
                         */
                        } else {
                            mxDestroyArray(a_);
                            {
                                mxArray * a_ = mclInitialize(line_search);
                                if (mlfTobool(a_)) {
                                    mxArray * b_4 = mclInitialize(
                                                      mlfNot(
                                                        mlfIsempty(
                                                          mlfIndexRef(
                                                            l,
                                                            "(?)",
                                                            lFinite))));
                                    if (mlfTobool(b_4)) {
                                        mlfAssign(&b_4, mlfScalar(1));
                                    } else {
                                        mlfAssign(
                                          &b_4,
                                          mlfOr(
                                            b_4,
                                            mlfNot(
                                              mlfIsempty(
                                                mlfIndexRef(
                                                  u, "(?)", uFinite)))));
                                    }
                                    mlfAssign(&a_, mlfAnd(a_, b_4));
                                    mxDestroyArray(b_4);
                                } else {
                                    mlfAssign(&a_, mlfScalar(0));
                                }
                                if (mlfTobool(a_)
                                    && mlfTobool(
                                         mlfAnd(
                                           a_,
                                           mlfGe(nfun, numberOfVariables)))) {
                                    mxDestroyArray(a_);
                                    /*
                                     * warnstr = sprintf('%s\n%s\n', ...
                                     */
                                    mlfAssign(
                                      &warnstr,
                                      mlfSprintf(
                                        NULL,
                                        mxCreateString("%s\\n%s\\n"),
                                        mxCreateString(
                                          "Line-search method does not "
                                          "handle bound constraints; "),
                                        mxCreateString(
                                          "   switching to large-s"
                                          "cale method instead."),
                                        NULL));
                                    /*
                                     * 'Line-search method does not handle bound constraints; ',...
                                     * '   switching to large-scale method instead.');
                                     * warning(warnstr);
                                     */
                                    mclAssignAns(
                                      &ans, mlfWarning(NULL, warnstr));
                                    /*
                                     * OUTPUT.algorithm = large;
                                     */
                                    mlfIndexAssign(OUTPUT, ".algorithm", large);
                                /*
                                 * 
                                 * % can't handle this one:   
                                 * elseif line_search & (~isempty(l(lFinite)) | ~isempty(u(uFinite)))  & nfun < numberOfVariables
                                 */
                                } else {
                                    mxDestroyArray(a_);
                                    {
                                        mxArray * a_ = mclInitialize(
                                                         line_search);
                                        if (mlfTobool(a_)) {
                                            mxArray * b_0 = mclInitialize(
                                                              mlfNot(
                                                                mlfIsempty(
                                                                  mlfIndexRef(
                                                                    l,
                                                                    "(?)",
                                                                    lFinite))));
                                            if (mlfTobool(b_0)) {
                                                mlfAssign(&b_0, mlfScalar(1));
                                            } else {
                                                mlfAssign(
                                                  &b_0,
                                                  mlfOr(
                                                    b_0,
                                                    mlfNot(
                                                      mlfIsempty(
                                                        mlfIndexRef(
                                                          u,
                                                          "(?)",
                                                          uFinite)))));
                                            }
                                            mlfAssign(&a_, mlfAnd(a_, b_0));
                                            mxDestroyArray(b_0);
                                        } else {
                                            mlfAssign(&a_, mlfScalar(0));
                                        }
                                        if (mlfTobool(a_)
                                            && mlfTobool(
                                                 mlfAnd(
                                                   a_,
                                                   mlfLt(
                                                     nfun,
                                                     numberOfVariables)))) {
                                            mxDestroyArray(a_);
                                            /*
                                             * errstr = sprintf('%s\n%s\n%s\n', ...
                                             */
                                            mlfAssign(
                                              &errstr,
                                              mlfSprintf(
                                                NULL,
                                                mxCreateString(
                                                  "%s\\n%s\\n%s\\n"),
                                                mxCreateString(
                                                  "Line-search method does not "
                                                  "handle bound constraints "),
                                                mxCreateString(
                                                  "   and large-scale method "
                                                  "requires at least as many "
                                                  "equations as variables; "),
                                                mxCreateString("   aborting."),
                                                NULL));
                                            /*
                                             * 'Line-search method does not handle bound constraints ',...
                                             * '   and large-scale method requires at least as many equations as variables; ',...
                                             * '   aborting.');
                                             * error(errstr);  
                                             */
                                            mlfError(errstr);
                                        } else {
                                            mxDestroyArray(a_);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     * if diagnostics > 0
     */
    if (mlfTobool(mlfGt(diagnostics, mlfScalar(0.0)))) {
        /*
         * % Do diagnostics on information so far
         * constflag = 0; gradconstflag = 0; non_eq=0;non_ineq=0;lin_eq=0;lin_ineq=0;
         */
        mlfAssign(&constflag, mlfScalar(0.0));
        mlfAssign(&gradconstflag, mlfScalar(0.0));
        mlfAssign(&non_eq, mlfScalar(0.0));
        mlfAssign(&non_ineq, mlfScalar(0.0));
        mlfAssign(&lin_eq, mlfScalar(0.0));
        mlfAssign(&lin_ineq, mlfScalar(0.0));
        /*
         * confcn{1}=[];c=[];ceq=[];cGRAD=[];ceqGRAD=[];
         */
        mlfIndexAssign(&confcn, "{?}", mlfScalar(1.0), mclCreateEmptyArray());
        mlfAssign(&c, mclCreateEmptyArray());
        mlfAssign(&ceq, mclCreateEmptyArray());
        mlfAssign(&cGRAD, mclCreateEmptyArray());
        mlfAssign(&ceqGRAD, mclCreateEmptyArray());
        /*
         * hessflag = 0; HESS=[];
         */
        mlfAssign(&hessflag, mlfScalar(0.0));
        mlfAssign(&HESS, mclCreateEmptyArray());
        /*
         * msg = diagnose(caller,OUTPUT,gradflag,hessflag,constflag,gradconstflag,...
         */
        mlfAssign(
          &msg,
          mlfOptim_private_diagnose(
            caller,
            *OUTPUT,
            gradflag,
            hessflag,
            constflag,
            gradconstflag,
            line_search,
            options,
            xstart,
            non_eq,
            non_ineq,
            lin_eq,
            lin_ineq,
            l,
            u,
            funfcn,
            confcn,
            f,
            JAC,
            HESS,
            c,
            ceq,
            cGRAD,
            ceqGRAD));
    /*
     * line_search,options,xstart,non_eq,...
     * non_ineq,lin_eq,lin_ineq,l,u,funfcn,confcn,f,JAC,HESS,c,ceq,cGRAD,ceqGRAD);
     * end
     */
    }
    /*
     * 
     * % Execute algorithm
     * if isequal(OUTPUT.algorithm, large)
     */
    if (mlfTobool(
          mlfFeval(
            mclValueVarargout(),
            mlxIsequal,
            mlfIndexRef(*OUTPUT, ".algorithm"),
            large,
            NULL))) {
        /*
         * if ~gradflag % provide sparsity of Jacobian if not provided.
         */
        if (mlfTobool(mlfNot(gradflag))) {
            /*
             * Jstr = optimget(options,'JacobPattern',[]);
             */
            mlfAssign(
              &Jstr,
              mlfOptimget(
                options,
                mxCreateString("JacobPattern"),
                mclCreateEmptyArray()));
            /*
             * if isempty(Jstr)
             */
            if (mlfTobool(mlfIsempty(Jstr))) {
                /*
                 * % Put this code separate as it might generate OUT OF MEMORY error
                 * Jstr = sparse(ones(Jrows,Jcols));
                 */
                mlfAssign(
                  &Jstr,
                  mlfSparse(
                    mlfOnes(Jrows, Jcols, NULL), NULL, NULL, NULL, NULL, NULL));
            /*
             * end
             */
            }
        /*
         * else
         */
        } else {
            /*
             * Jstr = [];
             */
            mlfAssign(&Jstr, mclCreateEmptyArray());
        /*
         * end
         */
        }
        /*
         * [x,FVAL,LAMBDA,JACOB,EXITFLAG,OUTPUT]=...
         * snls(funfcn,x,l,u,verbosity,options,f,JAC,YDATA,caller,Jstr,computeLambda,varargin{:});
         */
        mlfAssign(
          &x,
          mlfOptim_private_snls(
            FVAL,
            LAMBDA,
            JACOB,
            EXITFLAG,
            OUTPUT,
            funfcn,
            x,
            l,
            u,
            verbosity,
            options,
            f,
            JAC,
            YDATA,
            caller,
            Jstr,
            computeLambda,
            mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
            NULL));
    /*
     * else 
     */
    } else {
        /*
         * [x,FVAL,JACOB,EXITFLAG,OUTPUT] = ...
         * nlsq(funfcn,x,verbosity,options,f,JAC,YDATA,caller,varargin{:});
         */
        mlfAssign(
          &x,
          mlfOptim_private_nlsq(
            FVAL,
            JACOB,
            EXITFLAG,
            OUTPUT,
            funfcn,
            x,
            verbosity,
            options,
            f,
            JAC,
            YDATA,
            caller,
            mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
            NULL));
        /*
         * LAMBDA.upper=[]; LAMBDA.lower=[];   
         */
        mlfIndexAssign(LAMBDA, ".upper", mclCreateEmptyArray());
        mlfIndexAssign(LAMBDA, ".lower", mclCreateEmptyArray());
    /*
     * end
     */
    }
    /*
     * Resnorm = FVAL'*FVAL;
     */
    mlfAssign(Resnorm, mlfMtimes(mlfCtranspose(*FVAL), *FVAL));
    /*
     * 
     * % Reset FVAL to shape of the user-function, fuser
     * FVAL = reshape(FVAL,size(fuser));
     */
    mlfAssign(
      FVAL, mlfReshape(*FVAL, mlfSize(mclValueVarargout(), fuser, NULL), NULL));
    /*
     * 
     * %--end of LSQNONLIN--
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     */
    return_:
    mclValidateOutputs(
      "lsqnonlin",
      7,
      nargout_,
      &x,
      Resnorm,
      FVAL,
      EXITFLAG,
      OUTPUT,
      LAMBDA,
      JACOB);
    mxDestroyArray(HESS);
    mxDestroyArray(JAC);
    mxDestroyArray(Jcols);
    mxDestroyArray(Jrows);
    mxDestroyArray(Jstr);
    mxDestroyArray(LB);
    mxDestroyArray(UB);
    mxDestroyArray(YDATA);
    mxDestroyArray(ans);
    mxDestroyArray(c);
    mxDestroyArray(cGRAD);
    mxDestroyArray(caller);
    mxDestroyArray(ceq);
    mxDestroyArray(ceqGRAD);
    mxDestroyArray(computeLambda);
    mxDestroyArray(confcn);
    mxDestroyArray(constflag);
    mxDestroyArray(defaultopt);
    mxDestroyArray(diagnostics);
    mxDestroyArray(errmsg);
    mxDestroyArray(errstr);
    mxDestroyArray(f);
    mxDestroyArray(funfcn);
    mxDestroyArray(fuser);
    mxDestroyArray(gradconstflag);
    mxDestroyArray(gradflag);
    mxDestroyArray(hessflag);
    mxDestroyArray(l);
    mxDestroyArray(lFinite);
    mxDestroyArray(large);
    mxDestroyArray(lin_eq);
    mxDestroyArray(lin_ineq);
    mxDestroyArray(line_search);
    mxDestroyArray(medium);
    mxDestroyArray(msg);
    mxDestroyArray(nargin_);
    mxDestroyArray(nargout);
    mxDestroyArray(nfun);
    mxDestroyArray(non_eq);
    mxDestroyArray(non_ineq);
    mxDestroyArray(numberOfVariables);
    mxDestroyArray(options);
    mxDestroyArray(u);
    mxDestroyArray(uFinite);
    mxDestroyArray(verbosity);
    mxDestroyArray(warnstr);
    mxDestroyArray(xstart);
    return x;
}

/*
 * The function "mlfNLsqnonlin" contains the nargout interface for the
 * "lsqnonlin" M-function from file "C:\MATLABR11\toolbox\optim\lsqnonlin.m"
 * (lines 1-254). This interface is only produced if the M-function uses the
 * special variable "nargout". The nargout interface allows the number of
 * requested outputs to be specified via the nargout argument, as opposed to
 * the normal interface which dynamically calculates the number of outputs
 * based on the number of non-NULL inputs it receives. This function processes
 * any input arguments and passes them to the implementation version of the
 * function, appearing above.
 */
mxArray * mlfNLsqnonlin(int nargout,
                        mxArray * * Resnorm,
                        mxArray * * FVAL,
                        mxArray * * EXITFLAG,
                        mxArray * * OUTPUT,
                        mxArray * * LAMBDA,
                        mxArray * * JACOB,
                        mxArray * FUN,
                        mxArray * x_,
                        mxArray * LB,
                        mxArray * UB,
                        mxArray * options,
                        ...) {
    mxArray * varargin = mclUnassigned();
    mxArray * x = mclGetUninitializedArray();
    mxArray * Resnorm__ = mclGetUninitializedArray();
    mxArray * FVAL__ = mclGetUninitializedArray();
    mxArray * EXITFLAG__ = mclGetUninitializedArray();
    mxArray * OUTPUT__ = mclGetUninitializedArray();
    mxArray * LAMBDA__ = mclGetUninitializedArray();
    mxArray * JACOB__ = mclGetUninitializedArray();
    mlfVarargin(&varargin, options, 0);
    mlfEnterNewContext(
      6,
      -6,
      Resnorm,
      FVAL,
      EXITFLAG,
      OUTPUT,
      LAMBDA,
      JACOB,
      FUN,
      x_,
      LB,
      UB,
      options,
      varargin);
    x
      = Mlsqnonlin(
          &Resnorm__,
          &FVAL__,
          &EXITFLAG__,
          &OUTPUT__,
          &LAMBDA__,
          &JACOB__,
          nargout,
          FUN,
          x_,
          LB,
          UB,
          options,
          varargin);
    mlfRestorePreviousContext(
      6,
      5,
      Resnorm,
      FVAL,
      EXITFLAG,
      OUTPUT,
      LAMBDA,
      JACOB,
      FUN,
      x_,
      LB,
      UB,
      options);
    mxDestroyArray(varargin);
    if (Resnorm != NULL) {
        mclCopyOutputArg(Resnorm, Resnorm__);
    } else {
        mxDestroyArray(Resnorm__);
    }
    if (FVAL != NULL) {
        mclCopyOutputArg(FVAL, FVAL__);
    } else {
        mxDestroyArray(FVAL__);
    }
    if (EXITFLAG != NULL) {
        mclCopyOutputArg(EXITFLAG, EXITFLAG__);
    } else {
        mxDestroyArray(EXITFLAG__);
    }
    if (OUTPUT != NULL) {
        mclCopyOutputArg(OUTPUT, OUTPUT__);
    } else {
        mxDestroyArray(OUTPUT__);
    }
    if (LAMBDA != NULL) {
        mclCopyOutputArg(LAMBDA, LAMBDA__);
    } else {
        mxDestroyArray(LAMBDA__);
    }
    if (JACOB != NULL) {
        mclCopyOutputArg(JACOB, JACOB__);
    } else {
        mxDestroyArray(JACOB__);
    }
    return mlfReturnValue(x);
}

/*
 * The function "mlfLsqnonlin" contains the normal interface for the
 * "lsqnonlin" M-function from file "C:\MATLABR11\toolbox\optim\lsqnonlin.m"
 * (lines 1-254). This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
mxArray * mlfLsqnonlin(mxArray * * Resnorm,
                       mxArray * * FVAL,
                       mxArray * * EXITFLAG,
                       mxArray * * OUTPUT,
                       mxArray * * LAMBDA,
                       mxArray * * JACOB,
                       mxArray * FUN,
                       mxArray * x_,
                       mxArray * LB,
                       mxArray * UB,
                       mxArray * options,
                       ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 1;
    mxArray * x = mclGetUninitializedArray();
    mxArray * Resnorm__ = mclGetUninitializedArray();
    mxArray * FVAL__ = mclGetUninitializedArray();
    mxArray * EXITFLAG__ = mclGetUninitializedArray();
    mxArray * OUTPUT__ = mclGetUninitializedArray();
    mxArray * LAMBDA__ = mclGetUninitializedArray();
    mxArray * JACOB__ = mclGetUninitializedArray();
    mlfVarargin(&varargin, options, 0);
    mlfEnterNewContext(
      6,
      -6,
      Resnorm,
      FVAL,
      EXITFLAG,
      OUTPUT,
      LAMBDA,
      JACOB,
      FUN,
      x_,
      LB,
      UB,
      options,
      varargin);
    if (Resnorm != NULL) {
        ++nargout;
    }
    if (FVAL != NULL) {
        ++nargout;
    }
    if (EXITFLAG != NULL) {
        ++nargout;
    }
    if (OUTPUT != NULL) {
        ++nargout;
    }
    if (LAMBDA != NULL) {
        ++nargout;
    }
    if (JACOB != NULL) {
        ++nargout;
    }
    x
      = Mlsqnonlin(
          &Resnorm__,
          &FVAL__,
          &EXITFLAG__,
          &OUTPUT__,
          &LAMBDA__,
          &JACOB__,
          nargout,
          FUN,
          x_,
          LB,
          UB,
          options,
          varargin);
    mlfRestorePreviousContext(
      6,
      5,
      Resnorm,
      FVAL,
      EXITFLAG,
      OUTPUT,
      LAMBDA,
      JACOB,
      FUN,
      x_,
      LB,
      UB,
      options);
    mxDestroyArray(varargin);
    if (Resnorm != NULL) {
        mclCopyOutputArg(Resnorm, Resnorm__);
    } else {
        mxDestroyArray(Resnorm__);
    }
    if (FVAL != NULL) {
        mclCopyOutputArg(FVAL, FVAL__);
    } else {
        mxDestroyArray(FVAL__);
    }
    if (EXITFLAG != NULL) {
        mclCopyOutputArg(EXITFLAG, EXITFLAG__);
    } else {
        mxDestroyArray(EXITFLAG__);
    }
    if (OUTPUT != NULL) {
        mclCopyOutputArg(OUTPUT, OUTPUT__);
    } else {
        mxDestroyArray(OUTPUT__);
    }
    if (LAMBDA != NULL) {
        mclCopyOutputArg(LAMBDA, LAMBDA__);
    } else {
        mxDestroyArray(LAMBDA__);
    }
    if (JACOB != NULL) {
        mclCopyOutputArg(JACOB, JACOB__);
    } else {
        mxDestroyArray(JACOB__);
    }
    return mlfReturnValue(x);
}

/*
 * The function "mlfVLsqnonlin" contains the void interface for the "lsqnonlin"
 * M-function from file "C:\MATLABR11\toolbox\optim\lsqnonlin.m" (lines 1-254).
 * The void interface is only produced if the M-function uses the special
 * variable "nargout", and has at least one output. The void interface function
 * specifies zero output arguments to the implementation version of the
 * function, and in the event that the implementation version still returns an
 * output (which, in MATLAB, would be assigned to the "ans" variable), it
 * deallocates the output. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlfVLsqnonlin(mxArray * FUN,
                   mxArray * x_,
                   mxArray * LB,
                   mxArray * UB,
                   mxArray * options,
                   ...) {
    mxArray * varargin = mclUnassigned();
    mxArray * x = mclUnassigned();
    mxArray * Resnorm = mclUnassigned();
    mxArray * FVAL = mclUnassigned();
    mxArray * EXITFLAG = mclUnassigned();
    mxArray * OUTPUT = mclUnassigned();
    mxArray * LAMBDA = mclUnassigned();
    mxArray * JACOB = mclUnassigned();
    mlfVarargin(&varargin, options, 0);
    mlfEnterNewContext(0, -6, FUN, x_, LB, UB, options, varargin);
    x
      = Mlsqnonlin(
          &Resnorm,
          &FVAL,
          &EXITFLAG,
          &OUTPUT,
          &LAMBDA,
          &JACOB,
          0,
          FUN,
          x_,
          LB,
          UB,
          options,
          varargin);
    mlfRestorePreviousContext(0, 5, FUN, x_, LB, UB, options);
    mxDestroyArray(varargin);
    mxDestroyArray(x);
    mxDestroyArray(Resnorm);
    mxDestroyArray(FVAL);
    mxDestroyArray(EXITFLAG);
    mxDestroyArray(OUTPUT);
    mxDestroyArray(LAMBDA);
}

/*
 * The function "mlxLsqnonlin" contains the feval interface for the "lsqnonlin"
 * M-function from file "C:\MATLABR11\toolbox\optim\lsqnonlin.m" (lines 1-254).
 * The feval function calls the implementation version of lsqnonlin through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxLsqnonlin(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[6];
    mxArray * mplhs[7];
    int i;
    if (nlhs > 7) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lsqnonlin Line: 1 Column:"
            " 0 The function \"lsqnonlin\" was called with m"
            "ore than the declared number of outputs (7)"));
    }
    for (i = 0; i < 7; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 5 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 5; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 5, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    mprhs[5] = NULL;
    mlfAssign(&mprhs[5], mclCreateVararginCell(nrhs - 5, prhs + 5));
    mplhs[0]
      = Mlsqnonlin(
          &mplhs[1],
          &mplhs[2],
          &mplhs[3],
          &mplhs[4],
          &mplhs[5],
          &mplhs[6],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5]);
    mlfRestorePreviousContext(
      0, 5, mprhs[0], mprhs[1], mprhs[2], mprhs[3], mprhs[4]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 7 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 7; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[5]);
}

/*
 * The function "Mlsqnonlin_fprefcnchk" is the implementation version of the
 * "lsqnonlin/fprefcnchk" M-function from file
 * "C:\MATLABR11\toolbox\optim\lsqnonlin.m" (lines 254-347). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function [allfcns,msg] = fprefcnchk(funstr,caller,lenVarIn,gradflag)
 */
static mxArray * Mlsqnonlin_fprefcnchk(mxArray * * msg,
                                       int nargout_,
                                       mxArray * funstr,
                                       mxArray * caller,
                                       mxArray * lenVarIn,
                                       mxArray * gradflag) {
    mxArray * allfcns = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * calltype = mclGetUninitializedArray();
    mxArray * errmsg = mclGetUninitializedArray();
    mxArray * funfcn = mclGetUninitializedArray();
    mxArray * gradfcn = mclGetUninitializedArray();
    mxArray * warnstr = mclGetUninitializedArray();
    mclValidateInputs(
      "lsqnonlin/fprefcnchk", 4, &funstr, &caller, &lenVarIn, &gradflag);
    /*
     * %PREFCNCHK Pre- and post-process function expression for FUNCHK.
     * %   [ALLFCNS,MSG] = PREFUNCHK(FUNSTR,CALLER,lenVarIn,GRADFLAG) takes
     * %   the (nonempty) expression FUNSTR from CALLER with LenVarIn extra arguments,
     * %   parses it according to what CALLER is, then returns a string or inline
     * %   object in ALLFCNS.  If an error occurs, this message is put in MSG.
     * %
     * %   ALLFCNS is a cell array: 
     * %    ALLFCNS{1} contains a flag 
     * %    that says if the objective and gradients are together in one function 
     * %    (calltype=='fungrad') or in two functions (calltype='fun_then_grad')
     * %    or there is no gradient (calltype=='fun'), etc.
     * %    ALLFCNS{2} contains the string CALLER.
     * %    ALLFCNS{3}  contains the objective function
     * %    ALLFCNS{4}  contains the gradient function (transpose of Jacobian).
     * %  
     * %    NOTE: we assume FUNSTR is nonempty.
     * % Initialize
     * msg='';
     */
    mlfAssign(msg, mxCreateString(""));
    /*
     * allfcns = {};
     */
    mlfAssign(&allfcns, mclCreateEmptyCell());
    /*
     * funfcn = [];
     */
    mlfAssign(&funfcn, mclCreateEmptyArray());
    /*
     * gradfcn = [];
     */
    mlfAssign(&gradfcn, mclCreateEmptyArray());
    /*
     * 
     * if gradflag
     */
    if (mlfTobool(gradflag)) {
        /*
         * calltype = 'fungrad';
         */
        mlfAssign(&calltype, mxCreateString("fungrad"));
    /*
     * else
     */
    } else {
        /*
         * calltype = 'fun';
         */
        mlfAssign(&calltype, mxCreateString("fun"));
    /*
     * end
     */
    }
    /*
     * 
     * % {fun}
     * if isa(funstr, 'cell') & length(funstr)==1
     */
    {
        mxArray * a_ = mclInitialize(mlfIsa(funstr, mxCreateString("cell")));
        if (mlfTobool(a_)
            && mlfTobool(
                 mlfAnd(a_, mlfEq(mlfLength(funstr), mlfScalar(1.0))))) {
            mxDestroyArray(a_);
            /*
             * % take the cellarray apart: we know it is nonempty
             * if gradflag
             */
            if (mlfTobool(gradflag)) {
                /*
                 * calltype = 'fungrad';
                 */
                mlfAssign(&calltype, mxCreateString("fungrad"));
            /*
             * end
             */
            }
            /*
             * [funfcn, msg] = fcnchk(funstr{1},lenVarIn);
             */
            mlfFeval(
              mlfVarargout(&funfcn, msg, NULL),
              mlxFcnchk,
              mlfIndexRef(funstr, "{?}", mlfScalar(1.0)),
              lenVarIn,
              NULL);
            /*
             * if ~isempty(msg)
             */
            if (mlfTobool(mlfNot(mlfIsempty(*msg)))) {
                /*
                 * error(msg);
                 */
                mlfError(*msg);
            /*
             * end
             */
            }
        /*
         * 
         * % {fun,[]}      
         * elseif isa(funstr, 'cell') & length(funstr)==2 & isempty(funstr{2})
         */
        } else {
            mxDestroyArray(a_);
            {
                mxArray * a_ = mclInitialize(
                                 mlfIsa(funstr, mxCreateString("cell")));
                if (mlfTobool(a_)) {
                    mlfAssign(
                      &a_,
                      mlfAnd(a_, mlfEq(mlfLength(funstr), mlfScalar(2.0))));
                } else {
                    mlfAssign(&a_, mlfScalar(0));
                }
                if (mlfTobool(a_)
                    && mlfTobool(
                         mlfAnd(
                           a_,
                           mlfFeval(
                             mclValueVarargout(),
                             mlxIsempty,
                             mlfIndexRef(funstr, "{?}", mlfScalar(2.0)),
                             NULL)))) {
                    mxDestroyArray(a_);
                    /*
                     * if gradflag
                     */
                    if (mlfTobool(gradflag)) {
                        /*
                         * calltype = 'fungrad';
                         */
                        mlfAssign(&calltype, mxCreateString("fungrad"));
                    /*
                     * end
                     */
                    }
                    /*
                     * [funfcn, msg] = fcnchk(funstr{1},lenVarIn);
                     */
                    mlfFeval(
                      mlfVarargout(&funfcn, msg, NULL),
                      mlxFcnchk,
                      mlfIndexRef(funstr, "{?}", mlfScalar(1.0)),
                      lenVarIn,
                      NULL);
                    /*
                     * if ~isempty(msg)
                     */
                    if (mlfTobool(mlfNot(mlfIsempty(*msg)))) {
                        /*
                         * error(msg);
                         */
                        mlfError(*msg);
                    /*
                     * end  
                     */
                    }
                /*
                 * 
                 * % {fun, grad}   
                 * elseif isa(funstr, 'cell') & length(funstr)==2 % and ~isempty(funstr{2})
                 */
                } else {
                    mxDestroyArray(a_);
                    {
                        mxArray * a_ = mclInitialize(
                                         mlfIsa(
                                           funstr, mxCreateString("cell")));
                        if (mlfTobool(a_)
                            && mlfTobool(
                                 mlfAnd(
                                   a_,
                                   mlfEq(
                                     mlfLength(funstr), mlfScalar(2.0))))) {
                            mxDestroyArray(a_);
                            /*
                             * 
                             * [funfcn, msg] = fcnchk(funstr{1},lenVarIn);
                             */
                            mlfFeval(
                              mlfVarargout(&funfcn, msg, NULL),
                              mlxFcnchk,
                              mlfIndexRef(funstr, "{?}", mlfScalar(1.0)),
                              lenVarIn,
                              NULL);
                            /*
                             * if ~isempty(msg)
                             */
                            if (mlfTobool(mlfNot(mlfIsempty(*msg)))) {
                                /*
                                 * error(msg);
                                 */
                                mlfError(*msg);
                            /*
                             * end  
                             */
                            }
                            /*
                             * [gradfcn, msg] = fcnchk(funstr{2},lenVarIn);
                             */
                            mlfFeval(
                              mlfVarargout(&gradfcn, msg, NULL),
                              mlxFcnchk,
                              mlfIndexRef(funstr, "{?}", mlfScalar(2.0)),
                              lenVarIn,
                              NULL);
                            /*
                             * if ~isempty(msg)
                             */
                            if (mlfTobool(mlfNot(mlfIsempty(*msg)))) {
                                /*
                                 * error(msg);
                                 */
                                mlfError(*msg);
                            /*
                             * end
                             */
                            }
                            /*
                             * calltype = 'fun_then_grad';
                             */
                            mlfAssign(
                              &calltype, mxCreateString("fun_then_grad"));
                            /*
                             * if ~gradflag
                             */
                            if (mlfTobool(mlfNot(gradflag))) {
                                /*
                                 * warnstr = ...
                                 */
                                mlfAssign(
                                  &warnstr,
                                  mlfSprintf(
                                    NULL,
                                    mxCreateString("%s\\n%s\\n%s\\n"),
                                    mxCreateString(
                                      "Jacobian function provided b"
                                      "ut OPTIONS.Jacobian='off';"),
                                    mxCreateString(
                                      "  ignoring Jacobian function an"
                                      "d using finite-differencing."),
                                    mxCreateString(
                                      "  Rerun with OPTIONS.Jacobian='"
                                      "on' to use Jacobian function."),
                                    NULL));
                                /*
                                 * sprintf('%s\n%s\n%s\n','Jacobian function provided but OPTIONS.Jacobian=''off'';', ...
                                 * '  ignoring Jacobian function and using finite-differencing.', ...
                                 * '  Rerun with OPTIONS.Jacobian=''on'' to use Jacobian function.');
                                 * warning(warnstr);
                                 */
                                mclAssignAns(&ans, mlfWarning(NULL, warnstr));
                                /*
                                 * calltype = 'fun';
                                 */
                                mlfAssign(&calltype, mxCreateString("fun"));
                            /*
                             * end   
                             */
                            }
                        /*
                         * 
                         * elseif ~isa(funstr, 'cell')  %Not a cell; is a string expression, function name string or inline object
                         */
                        } else {
                            mxDestroyArray(a_);
                            if (mlfTobool(
                                  mlfNot(
                                    mlfIsa(funstr, mxCreateString("cell"))))) {
                                /*
                                 * [funfcn, msg] = fcnchk(funstr,lenVarIn);
                                 */
                                mlfAssign(
                                  &funfcn,
                                  mlfFcnchk(msg, funstr, lenVarIn, NULL));
                                /*
                                 * if ~isempty(msg)
                                 */
                                if (mlfTobool(mlfNot(mlfIsempty(*msg)))) {
                                    /*
                                     * error(msg);
                                     */
                                    mlfError(*msg);
                                /*
                                 * end   
                                 */
                                }
                                /*
                                 * if gradflag % gradient and function in one function/M-file
                                 */
                                if (mlfTobool(gradflag)) {
                                    /*
                                     * gradfcn = funfcn; % Do this so graderr will print the correct name
                                     */
                                    mlfAssign(&gradfcn, funfcn);
                                /*
                                 * end  
                                 */
                                }
                            /*
                             * else
                             */
                            } else {
                                /*
                                 * errmsg = sprintf('%s\n%s', ...
                                 */
                                mlfAssign(
                                  &errmsg,
                                  mlfSprintf(
                                    NULL,
                                    mxCreateString("%s\\n%s"),
                                    mxCreateString(
                                      "FUN must be a function name, valid st"
                                      "ring expression, or inline object;"),
                                    mxCreateString(
                                      " or, FUN may be a cell array that "
                                      "contains these type of objects."),
                                    NULL));
                                /*
                                 * 'FUN must be a function name, valid string expression, or inline object;', ...
                                 * ' or, FUN may be a cell array that contains these type of objects.');
                                 * error(errmsg)
                                 */
                                mlfError(errmsg);
                            }
                        }
                    }
                }
            }
        }
    /*
     * end
     */
    }
    /*
     * 
     * allfcns{1} = calltype;
     */
    mlfIndexAssign(&allfcns, "{?}", mlfScalar(1.0), calltype);
    /*
     * allfcns{2} = caller;
     */
    mlfIndexAssign(&allfcns, "{?}", mlfScalar(2.0), caller);
    /*
     * allfcns{3} = funfcn;
     */
    mlfIndexAssign(&allfcns, "{?}", mlfScalar(3.0), funfcn);
    /*
     * allfcns{4} = gradfcn;
     */
    mlfIndexAssign(&allfcns, "{?}", mlfScalar(4.0), gradfcn);
    /*
     * allfcns{5}=[];
     */
    mlfIndexAssign(&allfcns, "{?}", mlfScalar(5.0), mclCreateEmptyArray());
    mclValidateOutputs("lsqnonlin/fprefcnchk", 2, nargout_, &allfcns, msg);
    mxDestroyArray(ans);
    mxDestroyArray(calltype);
    mxDestroyArray(errmsg);
    mxDestroyArray(funfcn);
    mxDestroyArray(gradfcn);
    mxDestroyArray(warnstr);
    /*
     * 
     * 
     */
    return allfcns;
}

/*
 * The function "mlfLsqnonlin_fprefcnchk" contains the normal interface for the
 * "lsqnonlin/fprefcnchk" M-function from file
 * "C:\MATLABR11\toolbox\optim\lsqnonlin.m" (lines 254-347). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
static mxArray * mlfLsqnonlin_fprefcnchk(mxArray * * msg,
                                         mxArray * funstr,
                                         mxArray * caller,
                                         mxArray * lenVarIn,
                                         mxArray * gradflag) {
    int nargout = 1;
    mxArray * allfcns = mclGetUninitializedArray();
    mxArray * msg__ = mclGetUninitializedArray();
    mlfEnterNewContext(1, 4, msg, funstr, caller, lenVarIn, gradflag);
    if (msg != NULL) {
        ++nargout;
    }
    allfcns
      = Mlsqnonlin_fprefcnchk(
          &msg__, nargout, funstr, caller, lenVarIn, gradflag);
    mlfRestorePreviousContext(1, 4, msg, funstr, caller, lenVarIn, gradflag);
    if (msg != NULL) {
        mclCopyOutputArg(msg, msg__);
    } else {
        mxDestroyArray(msg__);
    }
    return mlfReturnValue(allfcns);
}

/*
 * The function "mlxLsqnonlin_fprefcnchk" contains the feval interface for the
 * "lsqnonlin/fprefcnchk" M-function from file
 * "C:\MATLABR11\toolbox\optim\lsqnonlin.m" (lines 254-347). The feval function
 * calls the implementation version of lsqnonlin/fprefcnchk through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
static void mlxLsqnonlin_fprefcnchk(int nlhs,
                                    mxArray * plhs[],
                                    int nrhs,
                                    mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lsqnonlin/fprefcnchk Line: 254 Co"
            "lumn: 0 The function \"lsqnonlin/fprefcnchk\" was calle"
            "d with more than the declared number of outputs (2)"));
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: lsqnonlin/fprefcnchk Line: 254 Co"
            "lumn: 0 The function \"lsqnonlin/fprefcnchk\" was calle"
            "d with more than the declared number of inputs (4)"));
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0]
      = Mlsqnonlin_fprefcnchk(
          &mplhs[1], nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}
