/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:23 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_pcgr.h"

static mxArray * Moptim_private_pcgr(mxArray * * posdef,
                                     mxArray * * k,
                                     int nargout_,
                                     mxArray * DM,
                                     mxArray * DG,
                                     mxArray * g,
                                     mxArray * kmax,
                                     mxArray * tol,
                                     mxArray * mtxmpy,
                                     mxArray * fdata,
                                     mxArray * H,
                                     mxArray * R,
                                     mxArray * pR);
static mxArray * Mpcgr_preproj(int nargout_,
                               mxArray * r,
                               mxArray * RPCMTX,
                               mxArray * ppvec);
static mxArray * mlfPcgr_preproj(mxArray * r,
                                 mxArray * RPCMTX,
                                 mxArray * ppvec);
static void mlxPcgr_preproj(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]);

static mlfFunctionTableEntry local_function_table_[1]
  = { { "preproj", mlxPcgr_preproj, 3, 1 } };

/*
 * The function "Moptim_private_pcgr" is the implementation version of the
 * "optim/private/pcgr" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\pcgr.m" (lines 1-74). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function[p,posdef,k] = pcgr(DM,DG,g,kmax,tol,mtxmpy,fdata,H,R,pR);
 */
static mxArray * Moptim_private_pcgr(mxArray * * posdef,
                                     mxArray * * k,
                                     int nargout_,
                                     mxArray * DM,
                                     mxArray * DG,
                                     mxArray * g,
                                     mxArray * kmax,
                                     mxArray * tol,
                                     mxArray * mtxmpy,
                                     mxArray * fdata,
                                     mxArray * H,
                                     mxArray * R,
                                     mxArray * pR) {
    mxArray * p = mclGetUninitializedArray();
    mxArray * alpha = mclGetUninitializedArray();
    mxArray * beta = mclGetUninitializedArray();
    mxArray * d = mclGetUninitializedArray();
    mxArray * denom = mclGetUninitializedArray();
    mxArray * inner1 = mclGetUninitializedArray();
    mxArray * inner2 = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * m = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * r = mclGetUninitializedArray();
    mxArray * stoptol = mclGetUninitializedArray();
    mxArray * val = mclGetUninitializedArray();
    mxArray * w = mclGetUninitializedArray();
    mxArray * ww = mclGetUninitializedArray();
    mxArray * z = mclGetUninitializedArray();
    mxArray * znrm = mclGetUninitializedArray();
    mclValidateInputs(
      "optim/private/pcgr",
      10,
      &DM,
      &DG,
      &g,
      &kmax,
      &tol,
      &mtxmpy,
      &fdata,
      &H,
      &R,
      &pR);
    mclCopyArray(&kmax);
    /*
     * %PCGR	Preconditioned conjugate gradients
     * %
     * % [p,posdef,k] = PCGR(DM,DG,g,kmax,tol,mtxmpy,fdata,H,R,pR) apply
     * % a preconditioned conjugate gradient procedure to the quadratic
     * % 
     * %         q(p) = .5p'Mp + g'p, where
     * %
     * % M = DM*H*DM + DG. kmax is a bound on the number of permitted
     * % CG-iterations, tol is a stopping tolerance on the residual (default
     * % is tol = .1), mtxmpy is the function that computes products
     * % with the Hessian matrix H (possible using data fdata),  
     * % and R is the cholesky factor of the preconditioner (transpose) of
     * % M. So, R'R approximates M(pR,pR), where pR is a permutation vector.
     * % On ouput p is the computed direction, posdef = 1 implies
     * % only positive curvature (in M) has been detected; posdef = 0
     * % implies p is a direction of negative curvature (for M).
     * % Output parameter k is the number of CG-iterations used (which
     * % corresponds to the number of multiplications with H).
     * %
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.3 $  $Date: 1998/08/17 19:42:07 $
     * 
     * % Initializations.
     * n = length(DG);
     */
    mlfAssign(&n, mlfLength(DG));
    /*
     * r = -g; 
     */
    mlfAssign(&r, mlfUminus(g));
    /*
     * p = zeros(n,1); 
     */
    mlfAssign(&p, mlfZeros(n, mlfScalar(1.0), NULL));
    /*
     * val = 0;
     */
    mlfAssign(&val, mlfScalar(0.0));
    /*
     * m = 0;
     */
    mlfAssign(&m, mlfScalar(0.0));
    /*
     * 
     * % Precondition .
     * z = preproj(r,R,pR);
     */
    mlfAssign(&z, mlfPcgr_preproj(r, R, pR));
    /*
     * znrm = norm(z); 
     */
    mlfAssign(&znrm, mlfNorm(z, NULL));
    /*
     * stoptol = tol*znrm;
     */
    mlfAssign(&stoptol, mlfMtimes(tol, znrm));
    /*
     * inner2 = 0; 
     */
    mlfAssign(&inner2, mlfScalar(0.0));
    /*
     * inner1 = r'*z;
     */
    mlfAssign(&inner1, mlfMtimes(mlfCtranspose(r), z));
    /*
     * posdef = 1;
     */
    mlfAssign(posdef, mlfScalar(1.0));
    /*
     * 
     * kmax = max(kmax,1);  % kmax must be at least 1
     */
    mlfAssign(&kmax, mlfMax(NULL, kmax, mlfScalar(1.0), NULL));
    /*
     * % PRIMARY LOOP.
     * for k = 1:kmax
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), kmax, NULL);
         mclForNext(&iterator_0, k);
         ) {
        /*
         * if k==1
         */
        if (mlfTobool(mlfEq(*k, mlfScalar(1.0)))) {
            /*
             * d = z;
             */
            mlfAssign(&d, z);
        /*
         * else
         */
        } else {
            /*
             * beta = inner1/inner2;
             */
            mlfAssign(&beta, mlfMrdivide(inner1, inner2));
            /*
             * d = z + beta*d;
             */
            mlfAssign(&d, mlfPlus(z, mlfMtimes(beta, d)));
        /*
         * end
         */
        }
        /*
         * ww = DM*d; 
         */
        mlfAssign(&ww, mlfMtimes(DM, d));
        /*
         * w = feval(mtxmpy,ww,H,fdata);
         */
        mlfAssign(
          &w,
          mlfFeval(
            mclValueVarargout(),
            mclFevalLookup(mtxmpy, 1, local_function_table_),
            ww,
            H,
            fdata,
            NULL));
        /*
         * ww = DM*w +DG*d;
         */
        mlfAssign(&ww, mlfPlus(mlfMtimes(DM, w), mlfMtimes(DG, d)));
        /*
         * denom = d'*ww;
         */
        mlfAssign(&denom, mlfMtimes(mlfCtranspose(d), ww));
        /*
         * if denom <= 0
         */
        if (mlfTobool(mlfLe(denom, mlfScalar(0.0)))) {
            /*
             * p = d/norm(d);
             */
            mlfAssign(&p, mlfMrdivide(d, mlfNorm(d, NULL)));
            /*
             * posdef = 0;
             */
            mlfAssign(posdef, mlfScalar(0.0));
            /*
             * break
             */
            mclDestroyForLoopIterator(&iterator_0);
            break;
        /*
         * else
         */
        } else {
            /*
             * alpha = inner1/denom;
             */
            mlfAssign(&alpha, mlfMrdivide(inner1, denom));
            /*
             * p = p+ alpha*d;
             */
            mlfAssign(&p, mlfPlus(p, mlfMtimes(alpha, d)));
            /*
             * r = r - alpha*ww;
             */
            mlfAssign(&r, mlfMinus(r, mlfMtimes(alpha, ww)));
        /*
         * end
         */
        }
        /*
         * z = preproj(r,R,pR);
         */
        mlfAssign(&z, mlfPcgr_preproj(r, R, pR));
        /*
         * 
         * % Exit?
         * if norm(z) <= stoptol 
         */
        if (mlfTobool(mlfLe(mlfNorm(z, NULL), stoptol))) {
            /*
             * break; 
             */
            mclDestroyForLoopIterator(&iterator_0);
            break;
        /*
         * end
         */
        }
        /*
         * inner2 = inner1;
         */
        mlfAssign(&inner2, inner1);
        /*
         * inner1 = r'*z;
         */
        mlfAssign(&inner1, mlfMtimes(mlfCtranspose(r), z));
    /*
     * end
     */
    }
    mclValidateOutputs("optim/private/pcgr", 3, nargout_, &p, posdef, k);
    mxDestroyArray(alpha);
    mxDestroyArray(beta);
    mxDestroyArray(d);
    mxDestroyArray(denom);
    mxDestroyArray(inner1);
    mxDestroyArray(inner2);
    mxDestroyArray(kmax);
    mxDestroyArray(m);
    mxDestroyArray(n);
    mxDestroyArray(r);
    mxDestroyArray(stoptol);
    mxDestroyArray(val);
    mxDestroyArray(w);
    mxDestroyArray(ww);
    mxDestroyArray(z);
    mxDestroyArray(znrm);
    /*
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     */
    return p;
}

/*
 * The function "mlfOptim_private_pcgr" contains the normal interface for the
 * "optim/private/pcgr" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\pcgr.m" (lines 1-74). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_pcgr(mxArray * * posdef,
                                mxArray * * k,
                                mxArray * DM,
                                mxArray * DG,
                                mxArray * g,
                                mxArray * kmax,
                                mxArray * tol,
                                mxArray * mtxmpy,
                                mxArray * fdata,
                                mxArray * H,
                                mxArray * R,
                                mxArray * pR) {
    int nargout = 1;
    mxArray * p = mclGetUninitializedArray();
    mxArray * posdef__ = mclGetUninitializedArray();
    mxArray * k__ = mclGetUninitializedArray();
    mlfEnterNewContext(
      2, 10, posdef, k, DM, DG, g, kmax, tol, mtxmpy, fdata, H, R, pR);
    if (posdef != NULL) {
        ++nargout;
    }
    if (k != NULL) {
        ++nargout;
    }
    p
      = Moptim_private_pcgr(
          &posdef__,
          &k__,
          nargout,
          DM,
          DG,
          g,
          kmax,
          tol,
          mtxmpy,
          fdata,
          H,
          R,
          pR);
    mlfRestorePreviousContext(
      2, 10, posdef, k, DM, DG, g, kmax, tol, mtxmpy, fdata, H, R, pR);
    if (posdef != NULL) {
        mclCopyOutputArg(posdef, posdef__);
    } else {
        mxDestroyArray(posdef__);
    }
    if (k != NULL) {
        mclCopyOutputArg(k, k__);
    } else {
        mxDestroyArray(k__);
    }
    return mlfReturnValue(p);
}

/*
 * The function "mlxOptim_private_pcgr" contains the feval interface for the
 * "optim/private/pcgr" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\pcgr.m" (lines 1-74). The feval function
 * calls the implementation version of optim/private/pcgr through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxOptim_private_pcgr(int nlhs,
                           mxArray * plhs[],
                           int nrhs,
                           mxArray * prhs[]) {
    mxArray * mprhs[10];
    mxArray * mplhs[3];
    int i;
    if (nlhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/pcgr Line: 1 Colu"
            "mn: 0 The function \"optim/private/pcgr\" was called "
            "with more than the declared number of outputs (3)"));
    }
    if (nrhs > 10) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/pcgr Line: 1 Colu"
            "mn: 0 The function \"optim/private/pcgr\" was called "
            "with more than the declared number of inputs (10)"));
    }
    for (i = 0; i < 3; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 10 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 10; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      10,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9]);
    mplhs[0]
      = Moptim_private_pcgr(
          &mplhs[1],
          &mplhs[2],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7],
          mprhs[8],
          mprhs[9]);
    mlfRestorePreviousContext(
      0,
      10,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 3 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 3; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mpcgr_preproj" is the implementation version of the
 * "pcgr/preproj" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\pcgr.m" (lines 74-100). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function w = preproj(r,RPCMTX,ppvec);
 */
static mxArray * Mpcgr_preproj(int nargout_,
                               mxArray * r,
                               mxArray * RPCMTX,
                               mxArray * ppvec) {
    mxArray * w = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mxArray * one = mclGetUninitializedArray();
    mxArray * vtol = mclGetUninitializedArray();
    mxArray * wbar = mclGetUninitializedArray();
    mlfAssign(&nargin_, mlfNargin(0, r, RPCMTX, ppvec, NULL));
    mclValidateInputs("pcgr/preproj", 3, &r, &RPCMTX, &ppvec);
    mclCopyArray(&RPCMTX);
    mclCopyArray(&ppvec);
    /*
     * %PREPROJ Apply preconditioner
     * %
     * % w = preproj(r,RPCMTX,ppvec) Apply a preconditioner to vector r.
     * % The conceptual preconditioner is H(ppvec,ppvec) = RPCMTX'*RPCMTX
     * 
     * 
     * % Initialization
     * n = length(r);
     */
    mlfAssign(&n, mlfLength(r));
    /*
     * one = ones(n,1); 
     */
    mlfAssign(&one, mlfOnes(n, mlfScalar(1.0), NULL));
    /*
     * vtol = 100*eps*one; 
     */
    mlfAssign(&vtol, mlfMtimes(mlfMtimes(mlfScalar(100.0), mlfEps()), one));
    /*
     * 
     * if nargin < 3 | isempty(ppvec)
     */
    {
        mxArray * a_ = mclInitialize(mlfLt(nargin_, mlfScalar(3.0)));
        if (mlfTobool(a_) || mlfTobool(mlfOr(a_, mlfIsempty(ppvec)))) {
            mxDestroyArray(a_);
            /*
             * ppvec = (1:n); 
             */
            mlfAssign(&ppvec, mlfColon(mlfScalar(1.0), n, NULL));
            /*
             * if nargin < 2 | isempty(RPCMTX) 
             */
            {
                mxArray * a_ = mclInitialize(mlfLt(nargin_, mlfScalar(2.0)));
                if (mlfTobool(a_) || mlfTobool(mlfOr(a_, mlfIsempty(RPCMTX)))) {
                    mxDestroyArray(a_);
                    /*
                     * RPCMTX = speye(n); 
                     */
                    mlfAssign(&RPCMTX, mlfSpeye(n, NULL));
                } else {
                    mxDestroyArray(a_);
                }
            /*
             * end
             */
            }
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end 
     */
    }
    /*
     * 
     * %  Precondition
     * wbar = RPCMTX'\r(ppvec);
     */
    mlfAssign(
      &wbar, mlfMldivide(mlfCtranspose(RPCMTX), mlfIndexRef(r, "(?)", ppvec)));
    /*
     * w(ppvec,1) = RPCMTX\wbar;
     */
    mlfIndexAssign(
      &w, "(?,?)", ppvec, mlfScalar(1.0), mlfMldivide(RPCMTX, wbar));
    mclValidateOutputs("pcgr/preproj", 1, nargout_, &w);
    mxDestroyArray(RPCMTX);
    mxDestroyArray(n);
    mxDestroyArray(nargin_);
    mxDestroyArray(one);
    mxDestroyArray(ppvec);
    mxDestroyArray(vtol);
    mxDestroyArray(wbar);
    /*
     * 
     * 
     * 
     * 
     */
    return w;
}

/*
 * The function "mlfPcgr_preproj" contains the normal interface for the
 * "pcgr/preproj" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\pcgr.m" (lines 74-100). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
static mxArray * mlfPcgr_preproj(mxArray * r,
                                 mxArray * RPCMTX,
                                 mxArray * ppvec) {
    int nargout = 1;
    mxArray * w = mclGetUninitializedArray();
    mlfEnterNewContext(0, 3, r, RPCMTX, ppvec);
    w = Mpcgr_preproj(nargout, r, RPCMTX, ppvec);
    mlfRestorePreviousContext(0, 3, r, RPCMTX, ppvec);
    return mlfReturnValue(w);
}

/*
 * The function "mlxPcgr_preproj" contains the feval interface for the
 * "pcgr/preproj" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\pcgr.m" (lines 74-100). The feval
 * function calls the implementation version of pcgr/preproj through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
static void mlxPcgr_preproj(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: pcgr/preproj Line: 74 Colum"
            "n: 0 The function \"pcgr/preproj\" was called wit"
            "h more than the declared number of outputs (1)"));
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: pcgr/preproj Line: 74 Colum"
            "n: 0 The function \"pcgr/preproj\" was called wit"
            "h more than the declared number of inputs (3)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mpcgr_preproj(nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
}
