/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:23 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_trust.h"

static mxArray * Moptim_private_trust(mxArray * * val,
                                      mxArray * * posdef,
                                      mxArray * * count,
                                      mxArray * * lambda,
                                      int nargout_,
                                      mxArray * g,
                                      mxArray * H,
                                      mxArray * delta);
static mxArray * Mtrust_seceqn(int nargout_,
                               mxArray * lambda,
                               mxArray * eigval,
                               mxArray * alpha,
                               mxArray * delta);
static mxArray * mlfTrust_seceqn(mxArray * lambda,
                                 mxArray * eigval,
                                 mxArray * alpha,
                                 mxArray * delta);
static void mlxTrust_seceqn(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]);
static mxArray * Mtrust_rfzero(mxArray * * c,
                               mxArray * * itfun,
                               int nargout_,
                               mxArray * FunFcn,
                               mxArray * x,
                               mxArray * itbnd,
                               mxArray * eigval,
                               mxArray * alpha,
                               mxArray * delta,
                               mxArray * tol,
                               mxArray * trace);
static mxArray * mlfTrust_rfzero(mxArray * * c,
                                 mxArray * * itfun,
                                 mxArray * FunFcn,
                                 mxArray * x,
                                 mxArray * itbnd,
                                 mxArray * eigval,
                                 mxArray * alpha,
                                 mxArray * delta,
                                 mxArray * tol,
                                 mxArray * trace);
static void mlxTrust_rfzero(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]);

static mlfFunctionTableEntry local_function_table_[2]
  = { { "seceqn", mlxTrust_seceqn, 4, 1 },
      { "rfzero", mlxTrust_rfzero, 8, 3 } };

/*
 * The function "Moptim_private_trust" is the implementation version of the
 * "optim/private/trust" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 1-114). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function [s,val,posdef,count,lambda] = trust(g,H,delta)
 */
static mxArray * Moptim_private_trust(mxArray * * val,
                                      mxArray * * posdef,
                                      mxArray * * count,
                                      mxArray * * lambda,
                                      int nargout_,
                                      mxArray * g,
                                      mxArray * H,
                                      mxArray * delta) {
    mxArray * s = mclGetUninitializedArray();
    mxArray * D = mclGetUninitializedArray();
    mxArray * V = mclGetUninitializedArray();
    mxArray * alpha = mclGetUninitializedArray();
    mxArray * arg = mclGetUninitializedArray();
    mxArray * arg1 = mclGetUninitializedArray();
    mxArray * arg2 = mclGetUninitializedArray();
    mxArray * b = mclGetUninitializedArray();
    mxArray * beta = mclGetUninitializedArray();
    mxArray * c = mclGetUninitializedArray();
    mxArray * coeff = mclGetUninitializedArray();
    mxArray * eigval = mclGetUninitializedArray();
    mxArray * itbnd = mclGetUninitializedArray();
    mxArray * jmin = mclGetUninitializedArray();
    mxArray * key = mclGetUninitializedArray();
    mxArray * lam = mclGetUninitializedArray();
    mxArray * laminit = mclGetUninitializedArray();
    mxArray * mineig = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * nrms = mclGetUninitializedArray();
    mxArray * sig = mclGetUninitializedArray();
    mxArray * tol = mclGetUninitializedArray();
    mxArray * tol2 = mclGetUninitializedArray();
    mxArray * vval = mclGetUninitializedArray();
    mxArray * w = mclGetUninitializedArray();
    mclValidateInputs("optim/private/trust", 3, &g, &H, &delta);
    mclCopyArray(&H);
    /*
     * %TRUST	Exact soln of trust region problem
     * %
     * % [s,val,posdef,count,lambda] = TRUST(g,H,delta) Solves the trust region
     * % problem: min{g^Ts + 1/2 s^THs: ||s|| <= delta}. The full
     * % eigen-decomposition is used; based on the secular equation,
     * % 1/delta - 1/(||s||) = 0. The solution is s, the value
     * % of the quadratic at the solution is val; posdef = 1 if H
     * % is pos. definite; otherwise posdef = 0. The number of
     * % evaluations of the secular equation is count, lambda
     * % is the value of the corresponding Lagrange multiplier.
     * %
     * %
     * % TRUST is meant to be applied to very small dimensional problems.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.3 $  $Date: 1998/10/09 14:02:49 $
     * 
     * % INITIALIZATION
     * tol = 10^(-12); 
     */
    mlfAssign(&tol, mlfMpower(mlfScalar(10.0), mlfScalar(-12.0)));
    /*
     * tol2 = 10^(-8); 
     */
    mlfAssign(&tol2, mlfMpower(mlfScalar(10.0), mlfScalar(-8.0)));
    /*
     * key = 0; 
     */
    mlfAssign(&key, mlfScalar(0.0));
    /*
     * itbnd = 50;
     */
    mlfAssign(&itbnd, mlfScalar(50.0));
    /*
     * lambda = 0;
     */
    mlfAssign(lambda, mlfScalar(0.0));
    /*
     * n = length(g); 
     */
    mlfAssign(&n, mlfLength(g));
    /*
     * coeff(1:n,1) = zeros(n,1);
     */
    mlfIndexAssign(
      &coeff,
      "(?,?)",
      mlfColon(mlfScalar(1.0), n, NULL),
      mlfScalar(1.0),
      mlfZeros(n, mlfScalar(1.0), NULL));
    /*
     * H = full(H);
     */
    mlfAssign(&H, mlfFull(H));
    /*
     * [V,D] = eig(H); 
     */
    mlfAssign(&V, mlfEig(&D, H, NULL));
    /*
     * count = 0;
     */
    mlfAssign(count, mlfScalar(0.0));
    /*
     * eigval = diag(D); 
     */
    mlfAssign(&eigval, mlfDiag(D, NULL));
    /*
     * [mineig,jmin] = min(eigval);
     */
    mlfAssign(&mineig, mlfMin(&jmin, eigval, NULL, NULL));
    /*
     * alpha = -V'*g; 
     */
    mlfAssign(&alpha, mlfMtimes(mlfUminus(mlfCtranspose(V)), g));
    /*
     * sig = sign(alpha(jmin)) + (alpha(jmin)==0);
     */
    mlfAssign(
      &sig,
      mlfPlus(
        mlfSign(mlfIndexRef(alpha, "(?)", jmin)),
        mlfEq(mlfIndexRef(alpha, "(?)", jmin), mlfScalar(0.0))));
    /*
     * 
     * % POSITIVE DEFINITE CASE
     * if mineig > 0
     */
    if (mlfTobool(mlfGt(mineig, mlfScalar(0.0)))) {
        /*
         * coeff = alpha ./ eigval; 
         */
        mlfAssign(&coeff, mlfRdivide(alpha, eigval));
        /*
         * lambda = 0;
         */
        mlfAssign(lambda, mlfScalar(0.0));
        /*
         * s = V*coeff; 
         */
        mlfAssign(&s, mlfMtimes(V, coeff));
        /*
         * posdef = 1; 
         */
        mlfAssign(posdef, mlfScalar(1.0));
        /*
         * nrms = norm(s);
         */
        mlfAssign(&nrms, mlfNorm(s, NULL));
        /*
         * if nrms <= 1.2*delta
         */
        if (mlfTobool(mlfLe(nrms, mlfMtimes(mlfScalar(1.2), delta)))) {
            /*
             * key = 1;
             */
            mlfAssign(&key, mlfScalar(1.0));
        /*
         * else 
         */
        } else {
            /*
             * laminit = 0;
             */
            mlfAssign(&laminit, mlfScalar(0.0));
        /*
         * end
         */
        }
    /*
     * else
     */
    } else {
        /*
         * laminit = -mineig; 
         */
        mlfAssign(&laminit, mlfUminus(mineig));
        /*
         * posdef = 0;
         */
        mlfAssign(posdef, mlfScalar(0.0));
    /*
     * end
     */
    }
    /*
     * 
     * % INDEFINITE CASE
     * if key == 0
     */
    if (mlfTobool(mlfEq(key, mlfScalar(0.0)))) {
        /*
         * if seceqn(laminit,eigval,alpha,delta) > 0
         */
        if (mlfTobool(
              mlfGt(
                mlfTrust_seceqn(laminit, eigval, alpha, delta),
                mlfScalar(0.0)))) {
            /*
             * [b,c,count] = rfzero('seceqn',laminit,itbnd,eigval,alpha,delta,tol);
             */
            mlfAssign(
              &b,
              mlfTrust_rfzero(
                &c,
                count,
                mxCreateString("seceqn"),
                laminit,
                itbnd,
                eigval,
                alpha,
                delta,
                tol,
                NULL));
            /*
             * vval = abs(seceqn(b,eigval,alpha,delta));
             */
            mlfAssign(&vval, mlfAbs(mlfTrust_seceqn(b, eigval, alpha, delta)));
            /*
             * if abs(seceqn(b,eigval,alpha,delta)) <= tol2
             */
            if (mlfTobool(
                  mlfLe(
                    mlfAbs(mlfTrust_seceqn(b, eigval, alpha, delta)), tol2))) {
                /*
                 * lambda = b; 
                 */
                mlfAssign(lambda, b);
                /*
                 * key = 2;
                 */
                mlfAssign(&key, mlfScalar(2.0));
                /*
                 * lam = lambda*ones(n,1);
                 */
                mlfAssign(
                  &lam, mlfMtimes(*lambda, mlfOnes(n, mlfScalar(1.0), NULL)));
                /*
                 * w = eigval + lam;
                 */
                mlfAssign(&w, mlfPlus(eigval, lam));
                /*
                 * arg1 = (w==0) & (alpha == 0); 
                 */
                mlfAssign(
                  &arg1,
                  mlfAnd(
                    mlfEq(w, mlfScalar(0.0)), mlfEq(alpha, mlfScalar(0.0))));
                /*
                 * arg2 = (w==0) & (alpha ~= 0);
                 */
                mlfAssign(
                  &arg2,
                  mlfAnd(
                    mlfEq(w, mlfScalar(0.0)), mlfNe(alpha, mlfScalar(0.0))));
                /*
                 * coeff(w ~=0) = alpha(w ~=0) ./ w(w~=0);
                 */
                mlfIndexAssign(
                  &coeff,
                  "(?)",
                  mlfNe(w, mlfScalar(0.0)),
                  mlfRdivide(
                    mlfIndexRef(alpha, "(?)", mlfNe(w, mlfScalar(0.0))),
                    mlfIndexRef(w, "(?)", mlfNe(w, mlfScalar(0.0)))));
                /*
                 * coeff(arg1) = 0;
                 */
                mlfIndexAssign(&coeff, "(?)", arg1, mlfScalar(0.0));
                /*
                 * coeff(arg2) = Inf;
                 */
                mlfIndexAssign(&coeff, "(?)", arg2, mlfInf());
                /*
                 * coeff(isnan(coeff))=0;
                 */
                mlfIndexAssign(&coeff, "(?)", mlfIsnan(coeff), mlfScalar(0.0));
                /*
                 * s = V*coeff; 
                 */
                mlfAssign(&s, mlfMtimes(V, coeff));
                /*
                 * nrms = norm(s);
                 */
                mlfAssign(&nrms, mlfNorm(s, NULL));
                /*
                 * if (nrms > 1.2*delta) | (nrms < .8*delta)
                 */
                {
                    mxArray * a_ = mclInitialize(
                                     mlfGt(
                                       nrms, mlfMtimes(mlfScalar(1.2), delta)));
                    if (mlfTobool(a_)
                        || mlfTobool(
                             mlfOr(
                               a_,
                               mlfLt(
                                 nrms, mlfMtimes(mlfScalar(.8), delta))))) {
                        mxDestroyArray(a_);
                        /*
                         * key = 5; 
                         */
                        mlfAssign(&key, mlfScalar(5.0));
                        /*
                         * lambda = -mineig;
                         */
                        mlfAssign(lambda, mlfUminus(mineig));
                    } else {
                        mxDestroyArray(a_);
                    }
                /*
                 * end
                 */
                }
            /*
             * else
             */
            } else {
                /*
                 * lambda = -mineig; 
                 */
                mlfAssign(lambda, mlfUminus(mineig));
                /*
                 * key = 3;
                 */
                mlfAssign(&key, mlfScalar(3.0));
            /*
             * end
             */
            }
        /*
         * else
         */
        } else {
            /*
             * lambda = -mineig; 
             */
            mlfAssign(lambda, mlfUminus(mineig));
            /*
             * key = 4;
             */
            mlfAssign(&key, mlfScalar(4.0));
        /*
         * end
         */
        }
        /*
         * lam = lambda*ones(n,1);
         */
        mlfAssign(&lam, mlfMtimes(*lambda, mlfOnes(n, mlfScalar(1.0), NULL)));
        /*
         * if (key > 2) 
         */
        if (mlfTobool(mlfGt(key, mlfScalar(2.0)))) {
            /*
             * arg = abs(eigval + lam) < 10 * eps * max(abs(eigval),ones(n,1));
             */
            mlfAssign(
              &arg,
              mlfLt(
                mlfAbs(mlfPlus(eigval, lam)),
                mlfMtimes(
                  mlfMtimes(mlfScalar(10.0), mlfEps()),
                  mlfMax(
                    NULL,
                    mlfAbs(eigval),
                    mlfOnes(n, mlfScalar(1.0), NULL),
                    NULL))));
            /*
             * alpha(arg) = 0;
             */
            mlfIndexAssign(&alpha, "(?)", arg, mlfScalar(0.0));
        /*
         * end
         */
        }
        /*
         * w = eigval + lam;
         */
        mlfAssign(&w, mlfPlus(eigval, lam));
        /*
         * arg1 = (w==0) & (alpha == 0); arg2 = (w==0) & (alpha ~= 0);
         */
        mlfAssign(
          &arg1,
          mlfAnd(mlfEq(w, mlfScalar(0.0)), mlfEq(alpha, mlfScalar(0.0))));
        mlfAssign(
          &arg2,
          mlfAnd(mlfEq(w, mlfScalar(0.0)), mlfNe(alpha, mlfScalar(0.0))));
        /*
         * coeff(w~=0) = alpha(w~=0) ./ w(w~=0);
         */
        mlfIndexAssign(
          &coeff,
          "(?)",
          mlfNe(w, mlfScalar(0.0)),
          mlfRdivide(
            mlfIndexRef(alpha, "(?)", mlfNe(w, mlfScalar(0.0))),
            mlfIndexRef(w, "(?)", mlfNe(w, mlfScalar(0.0)))));
        /*
         * coeff(arg1) = zeros(length(arg1(arg1>0)),1);
         */
        mlfIndexAssign(
          &coeff,
          "(?)",
          arg1,
          mlfZeros(
            mlfLength(mlfIndexRef(arg1, "(?)", mlfGt(arg1, mlfScalar(0.0)))),
            mlfScalar(1.0),
            NULL));
        /*
         * coeff(arg2) = Inf *ones(length(arg2(arg2>0)),1);
         */
        mlfIndexAssign(
          &coeff,
          "(?)",
          arg2,
          mlfMtimes(
            mlfInf(),
            mlfOnes(
              mlfLength(mlfIndexRef(arg2, "(?)", mlfGt(arg2, mlfScalar(0.0)))),
              mlfScalar(1.0),
              NULL)));
        /*
         * coeff(coeff==NaN)=zeros(length(coeff(coeff==NaN)),1);
         */
        mlfIndexAssign(
          &coeff,
          "(?)",
          mlfEq(coeff, mlfNan()),
          mlfZeros(
            mlfLength(mlfIndexRef(coeff, "(?)", mlfEq(coeff, mlfNan()))),
            mlfScalar(1.0),
            NULL));
        /*
         * coeff(coeff==NaN)=zeros(length(coeff(coeff==NaN)),1);
         */
        mlfIndexAssign(
          &coeff,
          "(?)",
          mlfEq(coeff, mlfNan()),
          mlfZeros(
            mlfLength(mlfIndexRef(coeff, "(?)", mlfEq(coeff, mlfNan()))),
            mlfScalar(1.0),
            NULL));
        /*
         * s = V*coeff; nrms = norm(s);
         */
        mlfAssign(&s, mlfMtimes(V, coeff));
        mlfAssign(&nrms, mlfNorm(s, NULL));
        /*
         * if (key > 2) & (nrms < .8*delta)
         */
        {
            mxArray * a_ = mclInitialize(mlfGt(key, mlfScalar(2.0)));
            if (mlfTobool(a_)
                && mlfTobool(
                     mlfAnd(
                       a_, mlfLt(nrms, mlfMtimes(mlfScalar(.8), delta))))) {
                mxDestroyArray(a_);
                /*
                 * beta = sqrt(delta^2 - nrms^2);
                 */
                mlfAssign(
                  &beta,
                  mlfSqrt(
                    mlfMinus(
                      mlfMpower(delta, mlfScalar(2.0)),
                      mlfMpower(nrms, mlfScalar(2.0)))));
                /*
                 * s = s + beta*sig*V(:,jmin);
                 */
                mlfAssign(
                  &s,
                  mlfPlus(
                    s,
                    mlfMtimes(
                      mlfMtimes(beta, sig),
                      mlfIndexRef(V, "(?,?)", mlfCreateColonIndex(), jmin))));
            } else {
                mxDestroyArray(a_);
            }
        /*
         * end
         */
        }
        /*
         * if (key > 2) & (nrms > 1.2*delta)
         */
        {
            mxArray * a_ = mclInitialize(mlfGt(key, mlfScalar(2.0)));
            if (mlfTobool(a_)
                && mlfTobool(
                     mlfAnd(
                       a_, mlfGt(nrms, mlfMtimes(mlfScalar(1.2), delta))))) {
                mxDestroyArray(a_);
                /*
                 * [b,c,count] = rfzero('seceqn',laminit,itbnd,eigval,alpha,delta,tol);
                 */
                mlfAssign(
                  &b,
                  mlfTrust_rfzero(
                    &c,
                    count,
                    mxCreateString("seceqn"),
                    laminit,
                    itbnd,
                    eigval,
                    alpha,
                    delta,
                    tol,
                    NULL));
                /*
                 * lambda = b; lam = lambda*(ones(n,1));
                 */
                mlfAssign(lambda, b);
                mlfAssign(
                  &lam, mlfMtimes(*lambda, mlfOnes(n, mlfScalar(1.0), NULL)));
                /*
                 * w = eigval + lam;
                 */
                mlfAssign(&w, mlfPlus(eigval, lam));
                /*
                 * arg1 = (w==0) & (alpha == 0); arg2 = (w==0) & (alpha ~= 0);
                 */
                mlfAssign(
                  &arg1,
                  mlfAnd(
                    mlfEq(w, mlfScalar(0.0)), mlfEq(alpha, mlfScalar(0.0))));
                mlfAssign(
                  &arg2,
                  mlfAnd(
                    mlfEq(w, mlfScalar(0.0)), mlfNe(alpha, mlfScalar(0.0))));
                /*
                 * coeff(w~=0) = alpha(w~=0) ./ w(w~=0);
                 */
                mlfIndexAssign(
                  &coeff,
                  "(?)",
                  mlfNe(w, mlfScalar(0.0)),
                  mlfRdivide(
                    mlfIndexRef(alpha, "(?)", mlfNe(w, mlfScalar(0.0))),
                    mlfIndexRef(w, "(?)", mlfNe(w, mlfScalar(0.0)))));
                /*
                 * coeff(arg1) = zeros(length(arg1(arg1>0)),1);
                 */
                mlfIndexAssign(
                  &coeff,
                  "(?)",
                  arg1,
                  mlfZeros(
                    mlfLength(
                      mlfIndexRef(arg1, "(?)", mlfGt(arg1, mlfScalar(0.0)))),
                    mlfScalar(1.0),
                    NULL));
                /*
                 * coeff(arg2) = Inf *ones(length(arg2(arg2>0)),1);
                 */
                mlfIndexAssign(
                  &coeff,
                  "(?)",
                  arg2,
                  mlfMtimes(
                    mlfInf(),
                    mlfOnes(
                      mlfLength(
                        mlfIndexRef(arg2, "(?)", mlfGt(arg2, mlfScalar(0.0)))),
                      mlfScalar(1.0),
                      NULL)));
                /*
                 * coeff(coeff==NaN)=zeros(length(coeff(coeff==NaN)),1);
                 */
                mlfIndexAssign(
                  &coeff,
                  "(?)",
                  mlfEq(coeff, mlfNan()),
                  mlfZeros(
                    mlfLength(
                      mlfIndexRef(coeff, "(?)", mlfEq(coeff, mlfNan()))),
                    mlfScalar(1.0),
                    NULL));
                /*
                 * s = V*coeff; nrms = norm(s);
                 */
                mlfAssign(&s, mlfMtimes(V, coeff));
                mlfAssign(&nrms, mlfNorm(s, NULL));
            } else {
                mxDestroyArray(a_);
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * val = g'*s + (.5*s)'*(H*s);
     */
    mlfAssign(
      val,
      mlfPlus(
        mlfMtimes(mlfCtranspose(g), s),
        mlfMtimes(
          mlfCtranspose(mlfMtimes(mlfScalar(.5), s)), mlfMtimes(H, s))));
    mclValidateOutputs(
      "optim/private/trust", 5, nargout_, &s, val, posdef, count, lambda);
    mxDestroyArray(D);
    mxDestroyArray(H);
    mxDestroyArray(V);
    mxDestroyArray(alpha);
    mxDestroyArray(arg);
    mxDestroyArray(arg1);
    mxDestroyArray(arg2);
    mxDestroyArray(b);
    mxDestroyArray(beta);
    mxDestroyArray(c);
    mxDestroyArray(coeff);
    mxDestroyArray(eigval);
    mxDestroyArray(itbnd);
    mxDestroyArray(jmin);
    mxDestroyArray(key);
    mxDestroyArray(lam);
    mxDestroyArray(laminit);
    mxDestroyArray(mineig);
    mxDestroyArray(n);
    mxDestroyArray(nrms);
    mxDestroyArray(sig);
    mxDestroyArray(tol);
    mxDestroyArray(tol2);
    mxDestroyArray(vval);
    mxDestroyArray(w);
    /*
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * function[value] = seceqn(lambda,eigval,alpha,delta);
     * %SEC	Secular equation
     * %
     * % value = SEC(lambda,eigval,alpha,delta) returns the value
     * % of the secular equation at a set of m points lambda
     * %
     * %
     * 
     * 
     * %
     * m = length(lambda); n = length(eigval);
     * unn = ones(n,1); unm = ones(m,1);
     * M = eigval*unm' + unn*lambda'; MC = M;
     * MM = alpha*unm';
     * M(M~=0) = MM(M~=0) ./ M(M~=0);
     * M(MC==0) = Inf*ones(size(MC(MC==0))); 
     * M = M.*M;
     * value = sqrt(unm ./ (M'*unn));
     * value(value==NaN) = zeros(length(value(value==NaN)),1);
     * value = (1/delta)*unm - value;
     * 
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     */
    return s;
}

/*
 * The function "mlfOptim_private_trust" contains the normal interface for the
 * "optim/private/trust" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 1-114). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_trust(mxArray * * val,
                                 mxArray * * posdef,
                                 mxArray * * count,
                                 mxArray * * lambda,
                                 mxArray * g,
                                 mxArray * H,
                                 mxArray * delta) {
    int nargout = 1;
    mxArray * s = mclGetUninitializedArray();
    mxArray * val__ = mclGetUninitializedArray();
    mxArray * posdef__ = mclGetUninitializedArray();
    mxArray * count__ = mclGetUninitializedArray();
    mxArray * lambda__ = mclGetUninitializedArray();
    mlfEnterNewContext(4, 3, val, posdef, count, lambda, g, H, delta);
    if (val != NULL) {
        ++nargout;
    }
    if (posdef != NULL) {
        ++nargout;
    }
    if (count != NULL) {
        ++nargout;
    }
    if (lambda != NULL) {
        ++nargout;
    }
    s
      = Moptim_private_trust(
          &val__, &posdef__, &count__, &lambda__, nargout, g, H, delta);
    mlfRestorePreviousContext(4, 3, val, posdef, count, lambda, g, H, delta);
    if (val != NULL) {
        mclCopyOutputArg(val, val__);
    } else {
        mxDestroyArray(val__);
    }
    if (posdef != NULL) {
        mclCopyOutputArg(posdef, posdef__);
    } else {
        mxDestroyArray(posdef__);
    }
    if (count != NULL) {
        mclCopyOutputArg(count, count__);
    } else {
        mxDestroyArray(count__);
    }
    if (lambda != NULL) {
        mclCopyOutputArg(lambda, lambda__);
    } else {
        mxDestroyArray(lambda__);
    }
    return mlfReturnValue(s);
}

/*
 * The function "mlxOptim_private_trust" contains the feval interface for the
 * "optim/private/trust" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 1-114). The feval
 * function calls the implementation version of optim/private/trust through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxOptim_private_trust(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[5];
    int i;
    if (nlhs > 5) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/trust Line: 1 Colu"
            "mn: 0 The function \"optim/private/trust\" was called "
            "with more than the declared number of outputs (5)"));
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/trust Line: 1 Col"
            "umn: 0 The function \"optim/private/trust\" was calle"
            "d with more than the declared number of inputs (3)"));
    }
    for (i = 0; i < 5; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0]
      = Moptim_private_trust(
          &mplhs[1],
          &mplhs[2],
          &mplhs[3],
          &mplhs[4],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 5 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 5; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mtrust_seceqn" is the implementation version of the
 * "trust/seceqn" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 114-138). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function[value] = seceqn(lambda,eigval,alpha,delta);
 */
static mxArray * Mtrust_seceqn(int nargout_,
                               mxArray * lambda,
                               mxArray * eigval,
                               mxArray * alpha,
                               mxArray * delta) {
    mxArray * value = mclGetUninitializedArray();
    mxArray * M = mclGetUninitializedArray();
    mxArray * MC = mclGetUninitializedArray();
    mxArray * MM = mclGetUninitializedArray();
    mxArray * m = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * unm = mclGetUninitializedArray();
    mxArray * unn = mclGetUninitializedArray();
    mclValidateInputs("trust/seceqn", 4, &lambda, &eigval, &alpha, &delta);
    /*
     * %SEC	Secular equation
     * %
     * % value = SEC(lambda,eigval,alpha,delta) returns the value
     * % of the secular equation at a set of m points lambda
     * %
     * %
     * 
     * 
     * %
     * m = length(lambda); n = length(eigval);
     */
    mlfAssign(&m, mlfLength(lambda));
    mlfAssign(&n, mlfLength(eigval));
    /*
     * unn = ones(n,1); unm = ones(m,1);
     */
    mlfAssign(&unn, mlfOnes(n, mlfScalar(1.0), NULL));
    mlfAssign(&unm, mlfOnes(m, mlfScalar(1.0), NULL));
    /*
     * M = eigval*unm' + unn*lambda'; MC = M;
     */
    mlfAssign(
      &M,
      mlfPlus(
        mlfMtimes(eigval, mlfCtranspose(unm)),
        mlfMtimes(unn, mlfCtranspose(lambda))));
    mlfAssign(&MC, M);
    /*
     * MM = alpha*unm';
     */
    mlfAssign(&MM, mlfMtimes(alpha, mlfCtranspose(unm)));
    /*
     * M(M~=0) = MM(M~=0) ./ M(M~=0);
     */
    mlfIndexAssign(
      &M,
      "(?)",
      mlfNe(M, mlfScalar(0.0)),
      mlfRdivide(
        mlfIndexRef(MM, "(?)", mlfNe(M, mlfScalar(0.0))),
        mlfIndexRef(M, "(?)", mlfNe(M, mlfScalar(0.0)))));
    /*
     * M(MC==0) = Inf*ones(size(MC(MC==0))); 
     */
    mlfIndexAssign(
      &M,
      "(?)",
      mlfEq(MC, mlfScalar(0.0)),
      mlfMtimes(
        mlfInf(),
        mlfOnes(
          mlfSize(
            mclValueVarargout(),
            mlfIndexRef(MC, "(?)", mlfEq(MC, mlfScalar(0.0))),
            NULL),
          NULL)));
    /*
     * M = M.*M;
     */
    mlfAssign(&M, mlfTimes(M, M));
    /*
     * value = sqrt(unm ./ (M'*unn));
     */
    mlfAssign(
      &value, mlfSqrt(mlfRdivide(unm, mlfMtimes(mlfCtranspose(M), unn))));
    /*
     * value(value==NaN) = zeros(length(value(value==NaN)),1);
     */
    mlfIndexAssign(
      &value,
      "(?)",
      mlfEq(value, mlfNan()),
      mlfZeros(
        mlfLength(mlfIndexRef(value, "(?)", mlfEq(value, mlfNan()))),
        mlfScalar(1.0),
        NULL));
    /*
     * value = (1/delta)*unm - value;
     */
    mlfAssign(
      &value,
      mlfMinus(mlfMtimes(mlfMrdivide(mlfScalar(1.0), delta), unm), value));
    mclValidateOutputs("trust/seceqn", 1, nargout_, &value);
    mxDestroyArray(M);
    mxDestroyArray(MC);
    mxDestroyArray(MM);
    mxDestroyArray(m);
    mxDestroyArray(n);
    mxDestroyArray(unm);
    mxDestroyArray(unn);
    /*
     * 
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     */
    return value;
}

/*
 * The function "mlfTrust_seceqn" contains the normal interface for the
 * "trust/seceqn" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 114-138). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
static mxArray * mlfTrust_seceqn(mxArray * lambda,
                                 mxArray * eigval,
                                 mxArray * alpha,
                                 mxArray * delta) {
    int nargout = 1;
    mxArray * value = mclGetUninitializedArray();
    mlfEnterNewContext(0, 4, lambda, eigval, alpha, delta);
    value = Mtrust_seceqn(nargout, lambda, eigval, alpha, delta);
    mlfRestorePreviousContext(0, 4, lambda, eigval, alpha, delta);
    return mlfReturnValue(value);
}

/*
 * The function "mlxTrust_seceqn" contains the feval interface for the
 * "trust/seceqn" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 114-138). The feval
 * function calls the implementation version of trust/seceqn through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
static void mlxTrust_seceqn(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: trust/seceqn Line: 114 Colum"
            "n: 0 The function \"trust/seceqn\" was called with"
            " more than the declared number of outputs (1)"));
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: trust/seceqn Line: 114 Colu"
            "mn: 0 The function \"trust/seceqn\" was called wi"
            "th more than the declared number of inputs (4)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0] = Mtrust_seceqn(nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mtrust_rfzero" is the implementation version of the
 * "trust/rfzero" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 138-290). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function [b,c,itfun] = rfzero(FunFcn,x,itbnd,eigval,alpha,delta,tol,trace)
 */
static mxArray * Mtrust_rfzero(mxArray * * c,
                               mxArray * * itfun,
                               int nargout_,
                               mxArray * FunFcn,
                               mxArray * x,
                               mxArray * itbnd,
                               mxArray * eigval,
                               mxArray * alpha,
                               mxArray * delta,
                               mxArray * tol,
                               mxArray * trace) {
    mxArray * b = mclGetUninitializedArray();
    mxArray * a = mclGetUninitializedArray();
    mxArray * d = mclGetUninitializedArray();
    mxArray * dx = mclGetUninitializedArray();
    mxArray * e = mclGetUninitializedArray();
    mxArray * fa = mclGetUninitializedArray();
    mxArray * fb = mclGetUninitializedArray();
    mxArray * fc = mclGetUninitializedArray();
    mxArray * init = mclGetUninitializedArray();
    mxArray * m = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mxArray * p = mclGetUninitializedArray();
    mxArray * q = mclGetUninitializedArray();
    mxArray * r = mclGetUninitializedArray();
    mxArray * s = mclGetUninitializedArray();
    mxArray * sign = mclGetUninitializedArray();
    mxArray * step = mclGetUninitializedArray();
    mxArray * toler = mclGetUninitializedArray();
    mlfAssign(
      &nargin_,
      mlfNargin(0, FunFcn, x, itbnd, eigval, alpha, delta, tol, trace, NULL));
    mclValidateInputs(
      "trust/rfzero",
      8,
      &FunFcn,
      &x,
      &itbnd,
      &eigval,
      &alpha,
      &delta,
      &tol,
      &trace);
    mclCopyArray(&tol);
    mclCopyArray(&trace);
    /*
     * %RFZERO Find zero to the right
     * %
     * %	[b,c,itfun] = rfzero(FunFcn,x,itbnd,eigval,alpha,delta,tol,trace)
     * %	Zero of a function of one variable to the RIGHT of the
     * %       starting point x. A small modification of the M-file fzero,
     * %       described below, to ensure a zero to the Right of x is
     * %       searched for.
     * %
     * %	RFZERO is a slightly modified version of function FZERO
     * 
     * 
     * 
     * 
     * %	FZERO(F,X) finds a zero of f(x).  F is a string containing the
     * %	name of a real-valued function of a single real variable.   X is
     * %	a starting guess.  The value returned is near a point where F
     * %	changes sign.  For example, FZERO('sin',3) is pi.  Note the
     * %	quotes around sin.  Ordinarily, functions are defined in M-files.
     * %
     * %	An optional third argument sets the relative tolerance for the
     * %	convergence test.   The presence of an nonzero optional fourth
     * %	argument triggers a printing trace of the steps.
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * %	C.B. Moler 1-19-86
     * %	Revised CBM 3-25-87, LS 12-01-88.
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * %  This algorithm was originated by T. Dekker.  An Algol 60 version,
     * %  with some improvements, is given by Richard Brent in "Algorithms for
     * %  Minimization Without Derivatives", Prentice-Hall, 1973.  A Fortran
     * %  version is in Forsythe, Malcolm and Moler, "Computer Methods
     * %  for Mathematical Computations", Prentice-Hall, 1976.
     * %
     * % Initialization
     * if nargin < 7, trace = 0; tol = eps; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(7.0)))) {
        mlfAssign(&trace, mlfScalar(0.0));
        mlfAssign(&tol, mlfEps());
    }
    /*
     * if nargin == 7, trace = 0; end
     */
    if (mlfTobool(mlfEq(nargin_, mlfScalar(7.0)))) {
        mlfAssign(&trace, mlfScalar(0.0));
    }
    /*
     * if trace, clc, end
     */
    if (mlfTobool(trace)) {
        mlfClc();
    }
    /*
     * itfun = 0;
     */
    mlfAssign(itfun, mlfScalar(0.0));
    /*
     * %
     * %if x ~= 0, dx = x/20;
     * %if x ~= 0, dx = abs(x)/20;
     * if x~= 0, dx = abs(x)/2;
     */
    if (mlfTobool(mlfNe(x, mlfScalar(0.0)))) {
        mlfAssign(&dx, mlfMrdivide(mlfAbs(x), mlfScalar(2.0)));
    /*
     * %
     * %else, dx = 1/20;
     * else, dx = 1/2;
     */
    } else {
        mlfAssign(&dx, mlfMrdivide(mlfScalar(1.0), mlfScalar(2.0)));
    /*
     * end
     */
    }
    /*
     * %
     * %a = x - dx;  fa = feval(FunFcn,a,eigval,alpha,delta);
     * a = x; c = a;  fa = feval(FunFcn,a,eigval,alpha,delta);
     */
    mlfAssign(&a, x);
    mlfAssign(c, a);
    mlfAssign(
      &fa,
      mlfFeval(
        mclValueVarargout(),
        mclFevalLookup(FunFcn, 2, local_function_table_),
        a,
        eigval,
        alpha,
        delta,
        NULL));
    /*
     * itfun = itfun+1;
     */
    mlfAssign(itfun, mlfPlus(*itfun, mlfScalar(1.0)));
    /*
     * %
     * if trace
     */
    if (mlfTobool(trace)) {
        /*
         * %home
         * init = [a fa]
         */
        mlfAssign(&init, mlfHorzcat(a, fa, NULL));
        mclPrintArray(init, "init");
    /*
     * end
     */
    }
    /*
     * b = x + dx;
     */
    mlfAssign(&b, mlfPlus(x, dx));
    /*
     * b = x + 1;
     */
    mlfAssign(&b, mlfPlus(x, mlfScalar(1.0)));
    /*
     * fb = feval(FunFcn,b,eigval,alpha,delta);
     */
    mlfAssign(
      &fb,
      mlfFeval(
        mclValueVarargout(),
        mclFevalLookup(FunFcn, 2, local_function_table_),
        b,
        eigval,
        alpha,
        delta,
        NULL));
    /*
     * itfun = itfun+1;
     */
    mlfAssign(itfun, mlfPlus(*itfun, mlfScalar(1.0)));
    /*
     * if trace
     */
    if (mlfTobool(trace)) {
        /*
         * %home
         * init = [b fb]
         */
        mlfAssign(&init, mlfHorzcat(b, fb, NULL));
        mclPrintArray(init, "init");
    /*
     * end
     */
    }
    /*
     * 
     * % Find change of sign.
     * 
     * while (fa > 0) == (fb > 0)
     */
    while (mlfTobool(
             mlfEq(mlfGt(fa, mlfScalar(0.0)), mlfGt(fb, mlfScalar(0.0))))) {
        /*
         * dx = 2*dx;
         */
        mlfAssign(&dx, mlfMtimes(mlfScalar(2.0), dx));
        /*
         * %
         * %  a = x - dx;  fa = feval(FunFcn,a);
         * %  if trace, home, sign = [a fa], end
         * %
         * if (fa > 0) ~= (fb > 0), break, end
         */
        if (mlfTobool(
              mlfNe(mlfGt(fa, mlfScalar(0.0)), mlfGt(fb, mlfScalar(0.0))))) {
            break;
        }
        /*
         * b = x + dx;  fb = feval(FunFcn,b,eigval,alpha,delta);
         */
        mlfAssign(&b, mlfPlus(x, dx));
        mlfAssign(
          &fb,
          mlfFeval(
            mclValueVarargout(),
            mclFevalLookup(FunFcn, 2, local_function_table_),
            b,
            eigval,
            alpha,
            delta,
            NULL));
        /*
         * itfun = itfun+1;
         */
        mlfAssign(itfun, mlfPlus(*itfun, mlfScalar(1.0)));
        /*
         * if trace
         */
        if (mlfTobool(trace)) {
            /*
             * %home
             * sign = [b fb]
             */
            mlfAssign(&sign, mlfHorzcat(b, fb, NULL));
            mclPrintArray(sign, "sign");
        /*
         * end
         */
        }
        /*
         * if itfun > itbnd, break; end
         */
        if (mlfTobool(mlfGt(*itfun, itbnd))) {
            break;
        }
    /*
     * end
     */
    }
    /*
     * 
     * fc = fb;
     */
    mlfAssign(&fc, fb);
    /*
     * % Main loop, exit from middle of the loop
     * while fb ~= 0
     */
    while (mlfTobool(mlfNe(fb, mlfScalar(0.0)))) {
        /*
         * % Insure that b is the best result so far, a is the previous
         * % value of b, and c is on the opposite of the zero from b.
         * if (fb > 0) == (fc > 0)
         */
        if (mlfTobool(
              mlfEq(mlfGt(fb, mlfScalar(0.0)), mlfGt(fc, mlfScalar(0.0))))) {
            /*
             * c = a;  fc = fa;
             */
            mlfAssign(c, a);
            mlfAssign(&fc, fa);
            /*
             * d = b - a;  e = d;
             */
            mlfAssign(&d, mlfMinus(b, a));
            mlfAssign(&e, d);
        /*
         * end
         */
        }
        /*
         * if abs(fc) < abs(fb)
         */
        if (mlfTobool(mlfLt(mlfAbs(fc), mlfAbs(fb)))) {
            /*
             * a = b;    b = c;    c = a;
             */
            mlfAssign(&a, b);
            mlfAssign(&b, *c);
            mlfAssign(c, a);
            /*
             * fa = fb;  fb = fc;  fc = fa;
             */
            mlfAssign(&fa, fb);
            mlfAssign(&fb, fc);
            mlfAssign(&fc, fa);
        /*
         * end
         */
        }
        /*
         * 
         * % Convergence test and possible exit
         * %
         * if itfun > itbnd, break; end
         */
        if (mlfTobool(mlfGt(*itfun, itbnd))) {
            break;
        }
        /*
         * m = 0.5*(c - b);
         */
        mlfAssign(&m, mlfMtimes(mlfScalar(0.5), mlfMinus(*c, b)));
        /*
         * toler = 2.0*tol*max(abs(b),1.0);
         */
        mlfAssign(
          &toler,
          mlfMtimes(
            mlfMtimes(mlfScalar(2.0), tol),
            mlfMax(NULL, mlfAbs(b), mlfScalar(1.0), NULL)));
        /*
         * if (abs(m) <= toler) + (fb == 0.0), break, end
         */
        if (mlfTobool(
              mlfPlus(mlfLe(mlfAbs(m), toler), mlfEq(fb, mlfScalar(0.0))))) {
            break;
        }
        /*
         * 
         * % Choose bisection or interpolation
         * if (abs(e) < toler) + (abs(fa) <= abs(fb))
         */
        if (mlfTobool(
              mlfPlus(
                mlfLt(mlfAbs(e), toler), mlfLe(mlfAbs(fa), mlfAbs(fb))))) {
            /*
             * % Bisection
             * d = m;  e = m;
             */
            mlfAssign(&d, m);
            mlfAssign(&e, m);
        /*
         * else
         */
        } else {
            /*
             * % Interpolation
             * s = fb/fa;
             */
            mlfAssign(&s, mlfMrdivide(fb, fa));
            /*
             * if (a == c)
             */
            if (mlfTobool(mlfEq(a, *c))) {
                /*
                 * % Linear interpolation
                 * p = 2.0*m*s;
                 */
                mlfAssign(&p, mlfMtimes(mlfMtimes(mlfScalar(2.0), m), s));
                /*
                 * q = 1.0 - s;
                 */
                mlfAssign(&q, mlfMinus(mlfScalar(1.0), s));
            /*
             * else
             */
            } else {
                /*
                 * % Inverse quadratic interpolation
                 * q = fa/fc;
                 */
                mlfAssign(&q, mlfMrdivide(fa, fc));
                /*
                 * r = fb/fc;
                 */
                mlfAssign(&r, mlfMrdivide(fb, fc));
                /*
                 * p = s*(2.0*m*q*(q - r) - (b - a)*(r - 1.0));
                 */
                mlfAssign(
                  &p,
                  mlfMtimes(
                    s,
                    mlfMinus(
                      mlfMtimes(
                        mlfMtimes(mlfMtimes(mlfScalar(2.0), m), q),
                        mlfMinus(q, r)),
                      mlfMtimes(mlfMinus(b, a), mlfMinus(r, mlfScalar(1.0))))));
                /*
                 * q = (q - 1.0)*(r - 1.0)*(s - 1.0);
                 */
                mlfAssign(
                  &q,
                  mlfMtimes(
                    mlfMtimes(
                      mlfMinus(q, mlfScalar(1.0)), mlfMinus(r, mlfScalar(1.0))),
                    mlfMinus(s, mlfScalar(1.0))));
            /*
             * end;
             */
            }
            /*
             * if p > 0, q = -q; else p = -p; end;
             */
            if (mlfTobool(mlfGt(p, mlfScalar(0.0)))) {
                mlfAssign(&q, mlfUminus(q));
            } else {
                mlfAssign(&p, mlfUminus(p));
            }
            /*
             * % Is interpolated point acceptable
             * if (2.0*p < 3.0*m*q - abs(toler*q)) * (p < abs(0.5*e*q))
             */
            if (mlfTobool(
                  mlfMtimes(
                    mlfLt(
                      mlfMtimes(mlfScalar(2.0), p),
                      mlfMinus(
                        mlfMtimes(mlfMtimes(mlfScalar(3.0), m), q),
                        mlfAbs(mlfMtimes(toler, q)))),
                    mlfLt(
                      p,
                      mlfAbs(mlfMtimes(mlfMtimes(mlfScalar(0.5), e), q)))))) {
                /*
                 * e = d;  d = p/q;
                 */
                mlfAssign(&e, d);
                mlfAssign(&d, mlfMrdivide(p, q));
            /*
             * else
             */
            } else {
                /*
                 * d = m;  e = m;
                 */
                mlfAssign(&d, m);
                mlfAssign(&e, m);
            /*
             * end;
             */
            }
        /*
         * end % Interpolation
         */
        }
        /*
         * 
         * % Next point
         * a = b;
         */
        mlfAssign(&a, b);
        /*
         * fa = fb;
         */
        mlfAssign(&fa, fb);
        /*
         * if abs(d) > toler, b = b + d;
         */
        if (mlfTobool(mlfGt(mlfAbs(d), toler))) {
            mlfAssign(&b, mlfPlus(b, d));
        /*
         * else if b > c, b = b - toler;
         */
        } else {
            if (mlfTobool(mlfGt(b, *c))) {
                mlfAssign(&b, mlfMinus(b, toler));
            /*
             * else b = b + toler;
             */
            } else {
                mlfAssign(&b, mlfPlus(b, toler));
            /*
             * end
             */
            }
        /*
         * end
         */
        }
        /*
         * fb = feval(FunFcn,b,eigval,alpha,delta);
         */
        mlfAssign(
          &fb,
          mlfFeval(
            mclValueVarargout(),
            mclFevalLookup(FunFcn, 2, local_function_table_),
            b,
            eigval,
            alpha,
            delta,
            NULL));
        /*
         * itfun = itfun + 1;
         */
        mlfAssign(itfun, mlfPlus(*itfun, mlfScalar(1.0)));
        /*
         * if trace
         */
        if (mlfTobool(trace)) {
            /*
             * %home
             * step = [b fb]
             */
            mlfAssign(&step, mlfHorzcat(b, fb, NULL));
            mclPrintArray(step, "step");
        /*
         * end
         */
        }
    /*
     * end % Main loop
     */
    }
    mclValidateOutputs("trust/rfzero", 3, nargout_, &b, c, itfun);
    mxDestroyArray(a);
    mxDestroyArray(d);
    mxDestroyArray(dx);
    mxDestroyArray(e);
    mxDestroyArray(fa);
    mxDestroyArray(fb);
    mxDestroyArray(fc);
    mxDestroyArray(init);
    mxDestroyArray(m);
    mxDestroyArray(nargin_);
    mxDestroyArray(p);
    mxDestroyArray(q);
    mxDestroyArray(r);
    mxDestroyArray(s);
    mxDestroyArray(sign);
    mxDestroyArray(step);
    mxDestroyArray(tol);
    mxDestroyArray(toler);
    mxDestroyArray(trace);
    /*
     * 
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     * 
     * 
     * 
     */
    return b;
}

/*
 * The function "mlfTrust_rfzero" contains the normal interface for the
 * "trust/rfzero" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 138-290). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
static mxArray * mlfTrust_rfzero(mxArray * * c,
                                 mxArray * * itfun,
                                 mxArray * FunFcn,
                                 mxArray * x,
                                 mxArray * itbnd,
                                 mxArray * eigval,
                                 mxArray * alpha,
                                 mxArray * delta,
                                 mxArray * tol,
                                 mxArray * trace) {
    int nargout = 1;
    mxArray * b = mclGetUninitializedArray();
    mxArray * c__ = mclGetUninitializedArray();
    mxArray * itfun__ = mclGetUninitializedArray();
    mlfEnterNewContext(
      2, 8, c, itfun, FunFcn, x, itbnd, eigval, alpha, delta, tol, trace);
    if (c != NULL) {
        ++nargout;
    }
    if (itfun != NULL) {
        ++nargout;
    }
    b
      = Mtrust_rfzero(
          &c__,
          &itfun__,
          nargout,
          FunFcn,
          x,
          itbnd,
          eigval,
          alpha,
          delta,
          tol,
          trace);
    mlfRestorePreviousContext(
      2, 8, c, itfun, FunFcn, x, itbnd, eigval, alpha, delta, tol, trace);
    if (c != NULL) {
        mclCopyOutputArg(c, c__);
    } else {
        mxDestroyArray(c__);
    }
    if (itfun != NULL) {
        mclCopyOutputArg(itfun, itfun__);
    } else {
        mxDestroyArray(itfun__);
    }
    return mlfReturnValue(b);
}

/*
 * The function "mlxTrust_rfzero" contains the feval interface for the
 * "trust/rfzero" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trust.m" (lines 138-290). The feval
 * function calls the implementation version of trust/rfzero through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
static void mlxTrust_rfzero(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]) {
    mxArray * mprhs[8];
    mxArray * mplhs[3];
    int i;
    if (nlhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: trust/rfzero Line: 138 Colum"
            "n: 0 The function \"trust/rfzero\" was called with"
            " more than the declared number of outputs (3)"));
    }
    if (nrhs > 8) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: trust/rfzero Line: 138 Colu"
            "mn: 0 The function \"trust/rfzero\" was called wi"
            "th more than the declared number of inputs (8)"));
    }
    for (i = 0; i < 3; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 8 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 8; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      8,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7]);
    mplhs[0]
      = Mtrust_rfzero(
          &mplhs[1],
          &mplhs[2],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7]);
    mlfRestorePreviousContext(
      0,
      8,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 3 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 3; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}
