/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:16 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "seqmodfree.h"

extern mxArray * absLeftEnd1;
extern mxArray * absLeftEnd2;
extern mxArray * absRightEnd1;
extern mxArray * absRightEnd2;
extern mxArray * amps;
extern mxArray * chisq;
extern mxArray * data;
extern mxArray * fit;
extern mxArray * numTao;
extern mxArray * numTaoFixed;
extern mxArray * t;
extern mxArray * taoFixed;
extern mxArray * textBox;

static mxArray * Mseqmodfree_coeff(int nargout_, mxArray * taoFit);
static mxArray * mlfSeqmodfree_coeff(mxArray * taoFit);
static void mlxSeqmodfree_coeff(int nlhs,
                                mxArray * plhs[],
                                int nrhs,
                                mxArray * prhs[]);

/*
 * The function "Mseqmodfree" is the implementation version of the "seqmodfree"
 * M-function from file "C:\MATLABR11\asufit24\seqmodfree.m" (lines 1-65). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function f = seqmodfree(params)
 */
static mxArray * Mseqmodfree(int nargout_, mxArray * params) {
    mxArray * f = mclGetUninitializedArray();
    mxArray * a = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * datatemp = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * j = mclGetUninitializedArray();
    mxArray * shift = mclGetUninitializedArray();
    mxArray * sigma = mclGetUninitializedArray();
    mxArray * space = mclGetUninitializedArray();
    mxArray * tTemp = mclGetUninitializedArray();
    mxArray * taoFit = mclGetUninitializedArray();
    mxArray * z = mclGetUninitializedArray();
    mclValidateInputs("seqmodfree", 1, &params);
    /*
     * 
     * global data
     * global fit
     * global amps
     * global numTao
     * global numTaoFixed
     * global taoFixed
     * global t
     * global chisq
     * global textBox
     * global absLeftEnd1
     * global absRightEnd1
     * global absLeftEnd2
     * global absRightEnd2
     * 
     * %This is the function referred to in the call to "leastsq".
     * %It assumes the form:
     * %y(x)=a11*exp(-k1*t)+a12*exp(-k2*t)+. . .+a1n*exp(-kn*t)
     * %     a21*exp(-k1*t)+a22*exp(-k2*t)+. . .+a2n*exp(-kn*t)	
     * %     .
     * %     .
     * %     .
     * %     am1*exp(-k1*t)+am2*exp(-k2*t)+. . .+amn*exp(-kn*t)
     * %and makes available the vector of k values and the matrix
     * %of a values to the script file "fit.m".
     * 
     * tTemp = t(absLeftEnd1:absRightEnd1)-t(absLeftEnd1);
     */
    mlfAssign(
      &tTemp,
      mlfMinus(
        mlfIndexRef(t, "(?)", mlfColon(absLeftEnd1, absRightEnd1, NULL)),
        mlfIndexRef(t, "(?)", absLeftEnd1)));
    /*
     * tTemp=tTemp';
     */
    mlfAssign(&tTemp, mlfCtranspose(tTemp));
    /*
     * taoFit(1:numTaoFixed) = taoFixed.^-1;
     */
    mlfIndexAssign(
      &taoFit,
      "(?)",
      mlfColon(mlfScalar(1.0), numTaoFixed, NULL),
      mlfPower(taoFixed, mlfScalar(-1.0)));
    /*
     * taoFit(numTaoFixed + 1:numTaoFixed + numTao) = params(1:numTao).^-1;
     */
    mlfIndexAssign(
      &taoFit,
      "(?)",
      mlfColon(
        mlfPlus(numTaoFixed, mlfScalar(1.0)),
        mlfPlus(numTaoFixed, numTao),
        NULL),
      mlfPower(
        mlfIndexRef(params, "(?)", mlfColon(mlfScalar(1.0), numTao, NULL)),
        mlfScalar(-1.0)));
    /*
     * shift = params(numTao + 1) - t(absLeftEnd1);
     */
    mlfAssign(
      &shift,
      mlfMinus(
        mlfIndexRef(params, "(?)", mlfPlus(numTao, mlfScalar(1.0))),
        mlfIndexRef(t, "(?)", absLeftEnd1)));
    /*
     * sigma = params(numTao + 2)/2.355;
     */
    mlfAssign(
      &sigma,
      mlfMrdivide(
        mlfIndexRef(params, "(?)", mlfPlus(numTao, mlfScalar(2.0))),
        mlfScalar(2.355)));
    /*
     * space=zeros(length(tTemp),numTao+numTaoFixed);
     */
    mlfAssign(
      &space, mlfZeros(mlfLength(tTemp), mlfPlus(numTao, numTaoFixed), NULL));
    /*
     * for j = 1:(numTao + numTaoFixed)
     */
    for (mclForStart(
           &iterator_0, mlfScalar(1.0), mlfPlus(numTao, numTaoFixed), NULL);
         mclForNext(&iterator_0, &j);
         ) {
        /*
         * space(:,j) = exp(-taoFit(j)*tTemp).*(1+erf((tTemp-shift-taoFit(j)*sigma^2)/sqrt(2)/sigma))*exp(taoFit(j)*(shift+taoFit(j)*sigma^2/2));
         */
        mlfIndexAssign(
          &space,
          "(?,?)",
          mlfCreateColonIndex(),
          j,
          mlfMtimes(
            mlfTimes(
              mlfExp(
                mlfMtimes(mlfUminus(mlfIndexRef(taoFit, "(?)", j)), tTemp)),
              mlfPlus(
                mlfScalar(1.0),
                mlfErf(
                  mlfMrdivide(
                    mlfMrdivide(
                      mlfMinus(
                        mlfMinus(tTemp, shift),
                        mlfMtimes(
                          mlfIndexRef(taoFit, "(?)", j),
                          mlfMpower(sigma, mlfScalar(2.0)))),
                      mlfSqrt(mlfScalar(2.0))),
                    sigma)))),
            mlfExp(
              mlfMtimes(
                mlfIndexRef(taoFit, "(?)", j),
                mlfPlus(
                  shift,
                  mlfMrdivide(
                    mlfMtimes(
                      mlfIndexRef(taoFit, "(?)", j),
                      mlfMpower(sigma, mlfScalar(2.0))),
                    mlfScalar(2.0)))))));
    /*
     * end
     */
    }
    /*
     * %for j = 2:(numTao+numTaoFixed)
     * %    temp= zeros(size(tTemp));
     * %     for k=1:j
     * %       temp=temp+coeff(k,j,taoFit)*space(:,k);
     * %     end
     * %B=coeff(taoFit);
     * space=space*coeff(taoFit)';
     */
    mlfAssign(
      &space, mlfMtimes(space, mlfCtranspose(mlfSeqmodfree_coeff(taoFit))));
    /*
     * %end
     * datatemp = data(absLeftEnd2:absRightEnd2,absLeftEnd1:absRightEnd1)';
     */
    mlfAssign(
      &datatemp,
      mlfCtranspose(
        mlfIndexRef(
          data,
          "(?,?)",
          mlfColon(absLeftEnd2, absRightEnd2, NULL),
          mlfColon(absLeftEnd1, absRightEnd1, NULL))));
    /*
     * %z=space*ones(numTao+numTaoFixed,size(datatemp,2));
     * a= space\datatemp;
     */
    mlfAssign(&a, mlfMldivide(space, datatemp));
    /*
     * %a=ones(numTao+numTaoFixed,1)*a(1,:);
     * z = space*a;
     */
    mlfAssign(&z, mlfMtimes(space, a));
    /*
     * f = z - datatemp;
     */
    mlfAssign(&f, mlfMinus(z, datatemp));
    /*
     * fit = z';
     */
    mlfAssign(&fit, mlfCtranspose(z));
    /*
     * amps = a';
     */
    mlfAssign(&amps, mlfCtranspose(a));
    /*
     * %for j = 2:(numTao+numTaoFixed)
     * %    temp= coeff(1,j,taoFit);
     * %     for k=2:j
     * %       temp=temp+coeff(k,j,taoFit);
     * %     end
     * %    amps(:,j)=amps(:,j)*temp;
     * %end
     * chisq = trace(f'*f);
     */
    mlfAssign(&chisq, mlfTrace(mlfMtimes(mlfCtranspose(f), f)));
    /*
     * set(textBox,'string',['chisq = ' num2str(chisq)])
     */
    mclPrintAns(
      &ans,
      mlfNSet(
        0,
        textBox,
        mxCreateString("string"),
        mlfHorzcat(mxCreateString("chisq = "), mlfNum2str(chisq, NULL), NULL),
        NULL));
    /*
     * drawnow;
     */
    mlfDrawnow(NULL);
    mclValidateOutputs("seqmodfree", 1, nargout_, &f);
    mxDestroyArray(a);
    mxDestroyArray(ans);
    mxDestroyArray(datatemp);
    mxDestroyArray(j);
    mxDestroyArray(shift);
    mxDestroyArray(sigma);
    mxDestroyArray(space);
    mxDestroyArray(tTemp);
    mxDestroyArray(taoFit);
    mxDestroyArray(z);
    /*
     * 
     */
    return f;
}

/*
 * The function "mlfSeqmodfree" contains the normal interface for the
 * "seqmodfree" M-function from file "C:\MATLABR11\asufit24\seqmodfree.m"
 * (lines 1-65). This function processes any input arguments and passes them to
 * the implementation version of the function, appearing above.
 */
mxArray * mlfSeqmodfree(mxArray * params) {
    int nargout = 1;
    mxArray * f = mclGetUninitializedArray();
    mlfEnterNewContext(0, 1, params);
    f = Mseqmodfree(nargout, params);
    mlfRestorePreviousContext(0, 1, params);
    return mlfReturnValue(f);
}

/*
 * The function "mlxSeqmodfree" contains the feval interface for the
 * "seqmodfree" M-function from file "C:\MATLABR11\asufit24\seqmodfree.m"
 * (lines 1-65). The feval function calls the implementation version of
 * seqmodfree through this function. This function processes any input
 * arguments and passes them to the implementation version of the function,
 * appearing above.
 */
void mlxSeqmodfree(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: seqmodfree Line: 1 Column:"
            " 0 The function \"seqmodfree\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: seqmodfree Line: 1 Column"
            ": 0 The function \"seqmodfree\" was called with"
            " more than the declared number of inputs (1)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mseqmodfree(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mseqmodfree_coeff" is the implementation version of the
 * "seqmodfree/coeff" M-function from file "C:\MATLABR11\asufit24\seqmodfree.m"
 * (lines 65-76). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function B=coeff(taoFit)
 */
static mxArray * Mseqmodfree_coeff(int nargout_, mxArray * taoFit) {
    mxArray * B = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mclForLoopIterator iterator_1;
    mxArray * j = mclGetUninitializedArray();
    mclValidateInputs("seqmodfree/coeff", 1, &taoFit);
    /*
     * 
     * B=zeros(size(taoFit,2));
     */
    mlfAssign(
      &B, mlfZeros(mlfSize(mclValueVarargout(), taoFit, mlfScalar(2.0)), NULL));
    /*
     * B(1,1)=1;
     */
    mlfIndexAssign(&B, "(?,?)", mlfScalar(1.0), mlfScalar(1.0), mlfScalar(1.0));
    /*
     * if (size(taoFit,2)>=2)
     */
    if (mlfTobool(
          mlfGe(
            mlfSize(mclValueVarargout(), taoFit, mlfScalar(2.0)),
            mlfScalar(2.0)))) {
        /*
         * for i=2:length(taoFit)
         */
        for (mclForStart(&iterator_0, mlfScalar(2.0), mlfLength(taoFit), NULL);
             mclForNext(&iterator_0, &i);
             ) {
            /*
             * for j= 1:i
             */
            for (mclForStart(&iterator_1, mlfScalar(1.0), i, NULL);
                 mclForNext(&iterator_1, &j);
                 ) {
                /*
                 * B(i,j)=prod(taoFit(1:i-1))/prod(taoFit(find(taoFit(1:i)-taoFit(j)))-taoFit(j));
                 */
                mlfIndexAssign(
                  &B,
                  "(?,?)",
                  i,
                  j,
                  mlfMrdivide(
                    mlfProd(
                      mlfIndexRef(
                        taoFit,
                        "(?)",
                        mlfColon(
                          mlfScalar(1.0), mlfMinus(i, mlfScalar(1.0)), NULL)),
                      NULL),
                    mlfProd(
                      mlfMinus(
                        mlfIndexRef(
                          taoFit,
                          "(?)",
                          mlfFind(
                            NULL,
                            NULL,
                            mlfMinus(
                              mlfIndexRef(
                                taoFit,
                                "(?)",
                                mlfColon(mlfScalar(1.0), i, NULL)),
                              mlfIndexRef(taoFit, "(?)", j)))),
                        mlfIndexRef(taoFit, "(?)", j)),
                      NULL)));
            /*
             * end
             */
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    mclValidateOutputs("seqmodfree/coeff", 1, nargout_, &B);
    mxDestroyArray(i);
    mxDestroyArray(j);
    return B;
}

/*
 * The function "mlfSeqmodfree_coeff" contains the normal interface for the
 * "seqmodfree/coeff" M-function from file "C:\MATLABR11\asufit24\seqmodfree.m"
 * (lines 65-76). This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
static mxArray * mlfSeqmodfree_coeff(mxArray * taoFit) {
    int nargout = 1;
    mxArray * B = mclGetUninitializedArray();
    mlfEnterNewContext(0, 1, taoFit);
    B = Mseqmodfree_coeff(nargout, taoFit);
    mlfRestorePreviousContext(0, 1, taoFit);
    return mlfReturnValue(B);
}

/*
 * The function "mlxSeqmodfree_coeff" contains the feval interface for the
 * "seqmodfree/coeff" M-function from file "C:\MATLABR11\asufit24\seqmodfree.m"
 * (lines 65-76). The feval function calls the implementation version of
 * seqmodfree/coeff through this function. This function processes any input
 * arguments and passes them to the implementation version of the function,
 * appearing above.
 */
static void mlxSeqmodfree_coeff(int nlhs,
                                mxArray * plhs[],
                                int nrhs,
                                mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: seqmodfree/coeff Line: 65 Colu"
            "mn: 0 The function \"seqmodfree/coeff\" was called w"
            "ith more than the declared number of outputs (1)"));
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: seqmodfree/coeff Line: 65 Colu"
            "mn: 0 The function \"seqmodfree/coeff\" was called w"
            "ith more than the declared number of inputs (1)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mseqmodfree_coeff(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}
