/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "sfdnls.h"

/*
 * The function "Msfdnls" is the implementation version of the "sfdnls"
 * M-function from file "C:\MATLABR11\toolbox\optim\sfdnls.m" (lines 1-89). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function[J, ncol] = sfdnls(xcurr,valx,Jstr,group,alpha,fun,YDATA,varargin)
 */
static mxArray * Msfdnls(mxArray * * ncol,
                         int nargout_,
                         mxArray * xcurr,
                         mxArray * valx,
                         mxArray * Jstr,
                         mxArray * group,
                         mxArray * alpha,
                         mxArray * fun,
                         mxArray * YDATA,
                         mxArray * varargin) {
    mxArray * J = mclGetUninitializedArray();
    mxArray * A = mclGetUninitializedArray();
    mxArray * cols = mclGetUninitializedArray();
    mxArray * d = mclGetUninitializedArray();
    mxArray * epsi = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mxArray * ind = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * j = mclGetUninitializedArray();
    mxArray * k = mclGetUninitializedArray();
    mxArray * lpoint = mclGetUninitializedArray();
    mxArray * m = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mxArray * p = mclGetUninitializedArray();
    mxArray * v = mclGetUninitializedArray();
    mxArray * val = mclGetUninitializedArray();
    mxArray * w = mclGetUninitializedArray();
    mxArray * x = mclGetUninitializedArray();
    mxArray * xnrm = mclGetUninitializedArray();
    mxArray * y = mclGetUninitializedArray();
    mlfAssign(
      &nargin_,
      mlfNargin(
        1, xcurr, valx, Jstr, group, alpha, fun, YDATA, varargin, NULL));
    mclValidateInputs(
      "sfdnls", 7, &xcurr, &valx, &Jstr, &group, &alpha, &fun, &YDATA);
    mclCopyArray(&xcurr);
    mclCopyArray(&alpha);
    mclCopyArray(&YDATA);
    /*
     * %SFDNLS    Sparse Jacobian via finite differences
     * %
     * %
     * % J = sfdnls(x,valx,J,group,[],fun) returns the
     * % sparse finite difference approximation J of a Jacobian matrix
     * % of function 'fun'  at current point x.
     * % Vector group indicates how to use sparse finite differencing:
     * % group(i) = j means that column i belongs to group (or color) j.
     * % Each group (or color) corresponds to a function difference.
     * % varargin are extra parameters (possibly) needed by function 'fun'.
     * %
     * % J = sfdnls(x,valx,J,group,fdata,fun,alpha) overrides the default
     * % finite differencing stepsize.
     * %
     * %[J, ncol] = sfdnls(...) returns the number of function evaluations used
     * % in ncol.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.6 $  $Date: 1998/07/22 23:08:33 $
     * 
     * %
     * if nargin < 6
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(6.0)))) {
        /*
         * error('SFDNLS requires six arguments')
         */
        mlfError(mxCreateString("SFDNLS requires six arguments"));
    /*
     * elseif nargin < 7
     */
    } else if (mlfTobool(mlfLt(nargin_, mlfScalar(7.0)))) {
        /*
         * YDATA = [];
         */
        mlfAssign(&YDATA, mclCreateEmptyArray());
    /*
     * end
     */
    }
    /*
     * 
     * x = xcurr(:); % make it a vector
     */
    mlfAssign(&x, mlfIndexRef(xcurr, "(?)", mlfCreateColonIndex()));
    /*
     * [m,n] = size(Jstr); 
     */
    mlfSize(mlfVarargout(&m, &n, NULL), Jstr, NULL);
    /*
     * ncol = max(group); epsi = sqrt(eps);
     */
    mlfAssign(ncol, mlfMax(NULL, group, NULL, NULL));
    mlfAssign(&epsi, mlfSqrt(mlfEps()));
    /*
     * if isempty(alpha), 
     */
    if (mlfTobool(mlfIsempty(alpha))) {
        /*
         * alpha = ones(ncol,1)*sqrt(eps); 
         */
        mlfAssign(
          &alpha,
          mlfMtimes(mlfOnes(*ncol, mlfScalar(1.0), NULL), mlfSqrt(mlfEps())));
    /*
     * end
     */
    }
    /*
     * J = spones(Jstr); d = zeros(n,1);
     */
    mlfAssign(&J, mlfSpones(Jstr));
    mlfAssign(&d, mlfZeros(n, mlfScalar(1.0), NULL));
    /*
     * if ncol < n
     */
    if (mlfTobool(mlfLt(*ncol, n))) {
        /*
         * for k = 1:ncol
         */
        for (mclForStart(&iterator_0, mlfScalar(1.0), *ncol, NULL);
             mclForNext(&iterator_0, &k);
             ) {
            /*
             * d = (group == k);
             */
            mlfAssign(&d, mlfEq(group, k));
            /*
             * if nargin < 5
             */
            if (mlfTobool(mlfLt(nargin_, mlfScalar(5.0)))) {
                /*
                 * xnrm = norm(x(d));
                 */
                mlfAssign(&xnrm, mlfNorm(mlfIndexRef(x, "(?)", d), NULL));
                /*
                 * xnrm = max(xnrm,1);
                 */
                mlfAssign(&xnrm, mlfMax(NULL, xnrm, mlfScalar(1.0), NULL));
                /*
                 * alpha(k) = alpha(k)*xnrm;
                 */
                mlfIndexAssign(
                  &alpha,
                  "(?)",
                  k,
                  mlfMtimes(mlfIndexRef(alpha, "(?)", k), xnrm));
            /*
             * end
             */
            }
            /*
             * y = x + alpha(k)*d;
             */
            mlfAssign(
              &y, mlfPlus(x, mlfMtimes(mlfIndexRef(alpha, "(?)", k), d)));
            /*
             * 
             * %v = feval(fun,y,fdata);
             * xcurr(:) = y;  % reshape for userfunction
             */
            mlfIndexAssign(&xcurr, "(?)", mlfCreateColonIndex(), y);
            /*
             * v = feval(fun,xcurr,varargin{:});
             */
            mlfAssign(
              &v,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(fun, 0, NULL),
                xcurr,
                mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                NULL));
            /*
             * if ~isempty(YDATA)
             */
            if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                /*
                 * v = v - YDATA;
                 */
                mlfAssign(&v, mlfMinus(v, YDATA));
            /*
             * end
             */
            }
            /*
             * v = v(:);
             */
            mlfAssign(&v, mlfIndexRef(v, "(?)", mlfCreateColonIndex()));
            /*
             * 
             * w = (v-valx)/alpha(k);
             */
            mlfAssign(
              &w, mlfMrdivide(mlfMinus(v, valx), mlfIndexRef(alpha, "(?)", k)));
            /*
             * cols = find(d); 
             */
            mlfAssign(&cols, mlfFind(NULL, NULL, d));
            /*
             * 
             * lpoint = length(cols);
             */
            mlfAssign(&lpoint, mlfLength(cols));
            /*
             * A = sparse(m,n);
             */
            mlfAssign(&A, mlfSparse(m, n, NULL, NULL, NULL, NULL));
            /*
             * A(:,cols) = J(:,cols);
             */
            mlfIndexAssign(
              &A,
              "(?,?)",
              mlfCreateColonIndex(),
              cols,
              mlfIndexRef(J, "(?,?)", mlfCreateColonIndex(), cols));
            /*
             * J(:,cols) = J(:,cols) - A(:,cols);
             */
            mlfIndexAssign(
              &J,
              "(?,?)",
              mlfCreateColonIndex(),
              cols,
              mlfMinus(
                mlfIndexRef(J, "(?,?)", mlfCreateColonIndex(), cols),
                mlfIndexRef(A, "(?,?)", mlfCreateColonIndex(), cols)));
            /*
             * [i,j,val] = find(A);
             */
            mlfAssign(&i, mlfFind(&j, &val, A));
            /*
             * [p,ind] = sort(i);
             */
            mlfAssign(&p, mlfSort(&ind, i, NULL));
            /*
             * val(ind) = w(p);
             */
            mlfIndexAssign(&val, "(?)", ind, mlfIndexRef(w, "(?)", p));
            /*
             * A = sparse(i,j,full(val),m,n);
             */
            mlfAssign(&A, mlfSparse(i, j, mlfFull(val), m, n, NULL));
            /*
             * J = J + A;
             */
            mlfAssign(&J, mlfPlus(J, A));
        /*
         * end
         */
        }
    /*
     * else % ncol ==n
     */
    } else {
        /*
         * J = full(J);
         */
        mlfAssign(&J, mlfFull(J));
        /*
         * for k = 1:n
         */
        for (mclForStart(&iterator_0, mlfScalar(1.0), n, NULL);
             mclForNext(&iterator_0, &k);
             ) {
            /*
             * if nargin < 5
             */
            if (mlfTobool(mlfLt(nargin_, mlfScalar(5.0)))) {
                /*
                 * xnrm = norm(x(k));
                 */
                mlfAssign(&xnrm, mlfNorm(mlfIndexRef(x, "(?)", k), NULL));
                /*
                 * xnrm = max(xnrm,1);
                 */
                mlfAssign(&xnrm, mlfMax(NULL, xnrm, mlfScalar(1.0), NULL));
                /*
                 * alpha(k) = alpha(k)*xnrm;
                 */
                mlfIndexAssign(
                  &alpha,
                  "(?)",
                  k,
                  mlfMtimes(mlfIndexRef(alpha, "(?)", k), xnrm));
            /*
             * end
             */
            }
            /*
             * y = x;
             */
            mlfAssign(&y, x);
            /*
             * y(k) = y(k) + alpha(k);
             */
            mlfIndexAssign(
              &y,
              "(?)",
              k,
              mlfPlus(mlfIndexRef(y, "(?)", k), mlfIndexRef(alpha, "(?)", k)));
            /*
             * %v = feval(fun,y,fdata);
             * xcurr(:) = y;  % reshape for userfunction
             */
            mlfIndexAssign(&xcurr, "(?)", mlfCreateColonIndex(), y);
            /*
             * v = feval(fun,xcurr,varargin{:});
             */
            mlfAssign(
              &v,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(fun, 0, NULL),
                xcurr,
                mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                NULL));
            /*
             * if ~isempty(YDATA)
             */
            if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                /*
                 * v = v - YDATA;
                 */
                mlfAssign(&v, mlfMinus(v, YDATA));
            /*
             * end
             */
            }
            /*
             * v = v(:);
             */
            mlfAssign(&v, mlfIndexRef(v, "(?)", mlfCreateColonIndex()));
            /*
             * J(:,k) = (v-valx)/alpha(k);
             */
            mlfIndexAssign(
              &J,
              "(?,?)",
              mlfCreateColonIndex(),
              k,
              mlfMrdivide(mlfMinus(v, valx), mlfIndexRef(alpha, "(?)", k)));
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    mclValidateOutputs("sfdnls", 2, nargout_, &J, ncol);
    mxDestroyArray(A);
    mxDestroyArray(YDATA);
    mxDestroyArray(alpha);
    mxDestroyArray(cols);
    mxDestroyArray(d);
    mxDestroyArray(epsi);
    mxDestroyArray(i);
    mxDestroyArray(ind);
    mxDestroyArray(j);
    mxDestroyArray(k);
    mxDestroyArray(lpoint);
    mxDestroyArray(m);
    mxDestroyArray(n);
    mxDestroyArray(nargin_);
    mxDestroyArray(p);
    mxDestroyArray(v);
    mxDestroyArray(val);
    mxDestroyArray(w);
    mxDestroyArray(x);
    mxDestroyArray(xcurr);
    mxDestroyArray(xnrm);
    mxDestroyArray(y);
    /*
     * 
     * 
     */
    return J;
}

/*
 * The function "mlfSfdnls" contains the normal interface for the "sfdnls"
 * M-function from file "C:\MATLABR11\toolbox\optim\sfdnls.m" (lines 1-89).
 * This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfSfdnls(mxArray * * ncol,
                    mxArray * xcurr,
                    mxArray * valx,
                    mxArray * Jstr,
                    mxArray * group,
                    mxArray * alpha,
                    mxArray * fun,
                    mxArray * YDATA,
                    ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 1;
    mxArray * J = mclGetUninitializedArray();
    mxArray * ncol__ = mclGetUninitializedArray();
    mlfVarargin(&varargin, YDATA, 0);
    mlfEnterNewContext(
      1, -8, ncol, xcurr, valx, Jstr, group, alpha, fun, YDATA, varargin);
    if (ncol != NULL) {
        ++nargout;
    }
    J
      = Msfdnls(
          &ncol__,
          nargout,
          xcurr,
          valx,
          Jstr,
          group,
          alpha,
          fun,
          YDATA,
          varargin);
    mlfRestorePreviousContext(
      1, 7, ncol, xcurr, valx, Jstr, group, alpha, fun, YDATA);
    mxDestroyArray(varargin);
    if (ncol != NULL) {
        mclCopyOutputArg(ncol, ncol__);
    } else {
        mxDestroyArray(ncol__);
    }
    return mlfReturnValue(J);
}

/*
 * The function "mlxSfdnls" contains the feval interface for the "sfdnls"
 * M-function from file "C:\MATLABR11\toolbox\optim\sfdnls.m" (lines 1-89). The
 * feval function calls the implementation version of sfdnls through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxSfdnls(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[8];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: sfdnls Line: 1 Column: "
            "0 The function \"sfdnls\" was called with mor"
            "e than the declared number of outputs (2)"));
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 7 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 7; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      7,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6]);
    mprhs[7] = NULL;
    mlfAssign(&mprhs[7], mclCreateVararginCell(nrhs - 7, prhs + 7));
    mplhs[0]
      = Msfdnls(
          &mplhs[1],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7]);
    mlfRestorePreviousContext(
      0,
      7,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[7]);
}
